(function(){
  'use strict';

  angular
    .module('starter')
    .controller('MenuCtrl',MainCtrl);

  function MainCtrl($scope,$httpFactory,RouteData,$rootScope,localStorageService,$timeout,$cordovaAppVersion,$ionicPopup,$ionicScrollDelegate){
    {
      initMenuWidth();
      initBookList();
      $scope.chooseBook = chooseBook;
      $scope.myBook = RouteData.localBook;
      $scope.toUpdate = toUpdate;
      $timeout(function() {
        checkVersion();
      },1000);
    }

    function initMenuWidth(){
      if(window.screen.width<500){
        $scope.menuWidth = 275;
      }
      else if(window.screen.width>600){
        $scope.menuWidth = 500;
      }
      $scope.menuWidth = 275;
    }

    function initBookList(){
      $scope.bookList = _app.bookList;
      // $scope.bookList = localStorageService.get('allBook');   //优先取本地缓存
      // $httpFactory.book.bookList(-1).then(function(res){
      //   if(res.data.result == 0){
      //     $scope.bookList = res.data.object;
      //     localStorageService.set('allBook',$scope.bookList);
      //   }
      // });
    }

    function chooseBook(book){
      if(book == $rootScope.myBook){
        return;
      }

      $rootScope.myBook = book;
      // localStorageService.set('myBook',book);
      $ionicScrollDelegate.scrollTop();
      $rootScope.expLoading = true;
      $rootScope.practiceLoading = true;      // loading动画

      $rootScope.expList = localStorageService.get("exp_" + book.id);
      if($rootScope.expList){
        $rootScope.expLoading = false;      //关闭loading动画
      }

      $httpFactory.exp.expList(book.gradeId, book.subject).then(function (result) {
        $rootScope.expLoading = false;      //关闭loading动画
        if(result.status == -1){
          $rootScope.networkError = true;       //展示断网图
        }else {
          $rootScope.networkError = false;      //关闭断网图
          $rootScope.expList = result.data.object;// 所有实验
          !!result.data.object && localStorageService.set("exp_" + book.id, result.data.object)
        }
      });

      var local_practice = localStorageService.get("practice_" + book.id);
      if(local_exp){
        $rootScope.practiceLoading = false;      //关闭loading动画
        $rootScope.practiceList = local_practice;
        getChapter($rootScope.practiceList);
      }

      var userId = _appv.currentUser.userId?_appv.currentUser.userId:-1;
      $httpFactory.practice.chapter(userId,book.id).then(function(res){
        console.log(res)
        $rootScope.practiceLoading = false;      //关闭loading动画
        if(res.status == -1){
          $rootScope.networkError_practice = true;       //展示断网图
        }else {
          $rootScope.networkError_practice = false;      //关闭断网图
          $rootScope.practiceList = res.data.object;
          localStorageService.set("practice_" + book.id, res.data.object);
          getChapter($rootScope.practiceList);
        }
      });
    }

    function getChapter(practice){
      $rootScope.chapterList = [];
      // 获取所有章
      for(var i=0;i<practice.length;i++){
        if(practice[i].lever==1){
          practice[i].chapter = practice[i].name.split(' ')[0];
          practice[i].chapterName = practice[i].name.split(' ')[1];
          ($rootScope.chapterList.push(practice[i]));
        }
      }
      // 获取章里面所有节
      for(var i=0;i<$scope.chapterList.length;i++){
        $scope.chapterList[i].sectionList = [];
        for(var j=0;j<practice.length;j++){
          practice[j].lever==2 &&
          practice[j].parent_id==$scope.chapterList[i].id &&
          !practice[j].name.match("（综合）") &&
          !practice[j].name.match("中考要点总结") &&
          $rootScope.chapterList[i].sectionList.push(practice[j]);
        }
      }
    }

    function checkVersion(){
      if(_app.isWeb || _app.isIos){
        return;
      }
      $cordovaAppVersion.getVersionCode().then(function (response) {
        $httpFactory.sys.getVersion().then(function (res) {
          if (res.data.result == 0) {
            $scope.versionInfo = res.data.object[0];
            if ($scope.versionInfo.versionNo > response) {
              if (response >= 20600) {// 对应版本号 v2.6.0 2016年12月22日
                $scope.versionInfo.versionUrl = $scope.versionInfo.versionUrlNew;
              }
              updateVersion();
            }
          }
        });
      });
    }

    function updateVersion(){
      $scope.versionPopup = $ionicPopup.show({
        cssClass:'myPopup',
        templateUrl:'app/modal/version.html',
        scope:$scope
      })
    }

    function toUpdate(){
      window.open($scope.versionInfo.versionUrl, '_system');
    }
  }
})();
