/**
 * Created by Administrator on 2016/5/30 0030.
 */
(function () {
    'use strict';

    angular.module('starter')
        .controller('BrowserCtrl', MainController)

    function MainController($scope, $state, localStorageService, $ionicPopup, $stateParams, $ionicNavBarDelegate, $httpFactory,$ionicLoading) {

        {
            $scope.currentUser = window._appv.currentUser;
            $scope.fromMain = $stateParams.fromMain;
            $scope.navBack = navBack;
            $scope.openShare= openShare;
            $scope.share= share;

            //iframe标签打开网页
            var activity = $stateParams.activity;
            $scope._ios =window._app.isIos ? '_ios' : '';

            $scope.isTrue = false;//为假 ：

            var activityInfo; // initActivityInfo(); 中完成赋值
            var inviteCode=null;
            initActivityInfo();

            $scope.third={}
            window.share.wechat.installed().then(function (isInstalled) {
                if (1===isInstalled || !!isInstalled) {
                    $scope.third.hasWechat = true;
                } else {
                    $scope.third.hasWechat = false;
                }
            })
            window.share.qq.installed().then(function (isInstalled) {
                if (1===isInstalled || !!isInstalled) {
                    $scope.third.hasQQ = true;
                } else {
                    $scope.third.hasQQ = false;
                }
            })
        }

        /** function **************************/

        function navBack() {
            if (!$scope.fromMain) {
                $ionicNavBarDelegate.back();
            } else {
                if (!window._appv.currentUser) {
                    $state.go('login');
                }
                else {
                    if (!!localStorageService.get("bag")) {
                        localStorageService.get("versoinCheckShow") ? $state.go('main.exp') : $state.go('main.practice');
                    } else {
                        $state.go('myBag');
                    }
                }
            }
        }

        /*获取活动详情*/
        function initActivityInfo() {
            $httpFactory.browser($scope.currentUser.userId, activity.id).then(function (res) {
                if (res.data.result == 0) {
                    activityInfo = !!res.data.object[0] ? res.data.object[0] : res.data.object;

                    if (activityInfo == null) {
                        return;// 无数据
                    }

                    var join = activityInfo.webUrl.lastIndexOf('?') > -1 ? '&' : '?';
                    $("iframe").attr("src", activityInfo.webUrl + join + 'userId=' + $scope.currentUser.userId);

                } else {
                    $ionicLoading.show({template:"获取不到活动详情"});
                }
            })
        }

        function share(type) {
            var url = '';
            var mycode = ''
            if (!activityInfo) {
                $ionicLoading.show({template: '未获取到分享的信息；'});
                return;
            }
            if (!!inviteCode && (activityInfo.activityType == "invite" || activityInfo.activityType == window._app.activityType_invite)) {
                url = "?code=" + inviteCode;
                mycode = "我的邀请码：" + inviteCode;
            }
            $ionicLoading.show({template: 'Loading....', duration: 2000});

            switch (type) {
                case _app.shareType_wechat:
                    window.share.wechat.share(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
                        activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
                    return true;
                case _app.shareType_timeLine:
                    window.share.wechat.shareTimeLine(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
                        activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
                    return true;
                case _app.shareType_qq:
                    window.share.qq.share(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
                        activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
                    return true;
                case _app.shareType_qzone:
                    window.share.qq.shareToQzone(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
                        activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
                    return true;
            }
        }

        function success() {
            $ionicLoading.show({template: '分享成功'});
            $scope.sharePopup.close();
        }

        function fail() {
            $ionicLoading.show({template: '分享失败'});
        }

        function openShare() {
            $scope.sharePopup = $ionicPopup.show({
                cssClass: 'myPopup',
                templateUrl: 'app/share/share.html',
                scope: $scope
            });
        };


    }
})();

