(function () {
    'use strict';

    angular
        .module('starter')
        .controller('LiveCtrl', MainCtrl);

    function MainCtrl($scope,$ionicPopup,RouteData,$ionicLoading,$httpFactory,$rootScope,$state,$cordovaAppVersion){
        {
            var user = window._appv.currentUser;
            var token = window._appv.token;

            initData();
            initIosPayOpen();
            $scope.openShare = openShare;
            $scope.share = share;
            $scope.payLive = payLive;
            $rootScope.refresherLive = refresherLive;
            // initSysOpen();

        }

        function initData(){
            $scope.liveLoading = true;
            $httpFactory.live.getInfo(user.userId, token).then(function(res){
              $scope.liveLoading = false;
                if(res.data.result == 0 && res.data.object){
                    $scope.liveInfo = res.data.object;
                }else{
                    $ionicLoading.show({template:'暂没有直播安排，请耐心等待！'});
                }
            });
        }

        function initIosPayOpen(){
            $scope.isIos = _app.isIos;
            //数据库不配置开关则默认关
            !$rootScope.ios_isPayChoose && ($scope.iosPayOpen = false);
            //ios系统且有开关配置情况下
            $scope.isIos && $rootScope.ios_isPayChoose && ($scope.iosPayOpen = $rootScope.ios_isPayChoose.match('true')?true:false);
        }

        function openShare(){
            $scope.iosPayOpen = $rootScope.iosPayOpen;
            $scope.sharePopup = $ionicPopup.show({
                cssClass:'myPopup',
                templateUrl:'app/live/sharePopup.html',
                scope:$scope,
                anamite:'side-down-up'
            });
        }

        function share(type){
            $ionicLoading.show({template:'请稍等'});
            $httpFactory.sys.sysConfig('shareApp').then(function (res) {
                if(res.data.result == 0){
                    $scope.shareInfo = JSON.parse(res.data.object[0].value);
                    checkInstall(type);
                }else{
                    $ionicLoading.show({template:'没有获取到分享信息，请稍后再试'});
                }
            })
        }

        function checkInstall(type){
            var inviteCode = _appv.currentUser.inviteCode?_appv.currentUser.inviteCode:'';
            var title = $scope.shareInfo.params.title.replace('{{inviteCode}}',inviteCode);
            var description = $scope.shareInfo.params.description.replace('{{inviteCode}}',inviteCode);
            var thumb = $scope.shareInfo.params.thumb;
            var url = $scope.shareInfo.params.url;
            if(type=='qq'){
                //检测安装记录
                window.share.qq.installed().then(function(){
                    //分享
                    window.share.qq.shareToQzone(title,description,thumb,url).then(success,fail);
                },function(){
                    $ionicLoading.show({template:'没有检测到QQ的安装记录 或 QQ版本太低'});
                });
            }
            if(type=='wechat'){
                //检测安装记录
                window.share.wechat.installed().then(function(){
                    //分享
                    window.share.wechat.shareTimeLine(title,description,thumb,url).then(success,fail);
                },function(){
                    $ionicLoading.show({template:'没有检测到微信的安装记录 或 微信版本太低'});
                });
            }
        }

        function success(){
            $httpFactory.live.getPasswordShare(user.userId, token).then(function(res){
                if(res.data.result == 0){
                    $ionicLoading.show({template:'分享成功'});
                    $scope.sharePopup.close();
                    $scope.liveInfo.status = 2;
                    $scope.liveInfo.livePassword = res.data.object.livePassword;
                }
            })
        }

        function fail(){
            $ionicLoading.show({template:'分享失败'});
        }

        function payLive(){
            $scope.sharePopup.close();

            RouteData.productPay = {
                productType: _app.orderType_live,
                content: [{
                    productCode: $scope.liveInfo.product.code,
                    productName: $scope.liveInfo.product.name
                }],
                price: $scope.liveInfo.product.price
            };
            $state.go('menu.pay');
        }

        function refresherLive(){
            $httpFactory.live.getPasswordPay(user.userId, token).then(function(res){
                if(res.data.result==0 && res.data.object.status==2 && res.data.object.password){
                    $scope.liveInfo.status = 2;
                    $scope.liveInfo.livePassword = res.data.object.password;
                }
            });
        }

        function initSysOpen() {
            // $rootScope.isIos = _app.isIos;
            $rootScope.iosPayOpen = true;     //默认显示支付
            if (!!_app.isIos) {
                $rootScope.iosPayOpen = false;    //ios时默认关闭
                $cordovaAppVersion.getVersionNumber().then(function (response) {
                    var key = 'iosPayOpen_iosPayOpen_'+_config.platform.code+':' + response;
                    $httpFactory.sys.sysConfig(key).then(function (res) {
                        if (res.data.result == 0) {
                            $rootScope.iosPayOpen = res.data.object[0].value.match('true') ? true : false;
                        }
                    });
                });
            }
        }
    }
})();
