(function () {
    'use strict';

    angular
        .module('starter')
        .controller('ForgetPwdCtrl', MainCtrl);

    function MainCtrl($scope, $ionicHistory, $ionicLoading, $interval, CheckInputUtil, $httpFactory, $state, RouteData) {
        {
            $scope.sendCode = sendCode;
            $scope.toReset = toReset;
            $scope.navBack = navBack;

            $scope.text = '发送';
            $scope.second = 60;
            $scope.data={};
        }

        function navBack() {
            $ionicHistory.goBack();
        }

        function sendCode() {
            //检查
            var mobile = $scope.data.mobile;
            if (!mobile) {
                $ionicLoading.show({template: '请输入手机号码！'});
                return;
            }
            if (!CheckInputUtil.mobile(mobile)) {
                return;
            }

            //倒计时
            var timeStop = $interval(function () {
                if ($scope.second <= 0) {
                    $interval.cancel(timeStop);
                    $scope.text = '发送';
                    $scope.second = 60;
                    $scope.color = {};
                } else {
                    $scope.text = '已发送(' + $scope.second + ')';
                    $scope.color = {'color': '#959595'};
                    $scope.second--
                }
            }, 1000);

            //发送验证码
            var type = 1;       //重置密码类型
            $httpFactory.login.getCode(mobile, type).then(function (res) {
                if (res.data.result == 0) {
                    $ionicLoading.show({template: res.data.message});
                } else {
                    $ionicLoading.show({template: res.data.message});
                }
            })
        }

        function toReset() {
            var mobile = $scope.data.mobile;
            var code = $scope.data.code;
            if (!mobile) {
                $ionicLoading.show({template: '请输入手机号码！'});
                return;
            }
            if (!CheckInputUtil.mobile(mobile)) {
                return;
            }
            if (!code) {
                $ionicLoading.show({template: '请输入验证码！'});
                return;
            }
            if (code.match(' ')) {
                $ionicLoading.show({template: '验证码错误：包含有非法空格字符'});
                return;
            }
            var data = {
                randomCode: code,
                type: 1
            }
            $httpFactory.login.checkResetCode(mobile, data).then(function (res) {
                if (res.data.result == 0) {
                    RouteData.resetMobile = mobile;
                    RouteData.resetCode = code;
                    if(window._appv.currentUser && -1 !== window._appv.currentUser.userId){
                        $state.go('menu.reset1');
                    }else{
                        $state.go('reset');
                    }

                } else {
                    $ionicLoading.show({template: res.data.message})
                }
            });
        }
    }
})();
