(function () {
  'use strict';

  angular.module('starter').controller('LoginCtrl', MainCtrl);

  function MainCtrl(
    $scope,
    $interval,
    $httpFactory,
    $ionicLoading,
    $ionicPlatform,
    CheckInputUtil,
    $state,
    $rootScope,
    $ionicHistory,
    $http,
    localStorageService,
    $timeout,
    $ionicPopup,
    RouteData
  ) {
    {
      // checkInstall();        //第三方安装
      checkIosPage(); //ios独有样式
      initKeyboardListener(); //监听ios键盘打开事件
      refreshLoginInfo();
      initCanRegister();
      $scope.doLogin = doLogin;
      $scope.sendCode = sendCode;
      $scope.text = '发送';
      $scope.second = 60;
      $scope.changeLogin = changeLogin;
      $scope.toForgetPwd = toForgetPwd;
      $scope.navBack = navBack;
      $scope.loginQQ = loginQQ;
      $scope.loginWechat = loginWechat;
    }
    function initCanRegister() {
      if ($ionicPlatform.is('ios')) {
        $httpFactory.sys.sysConfig('msg_open').then(function (res) {
          if (res.data.result == 0) {
            // $scope.canRegister = true
            res.data.object[0].value === 'true' ? true : false;
          } else {
            $scope.canRegister = false;
          }
        });
      } else {
        $scope.canRegister = false;
      }
    }

    function navBack() {
      $ionicHistory.goBack();
      // $ionicViewSwitcher.nextDirection('back'); // 控制着动画(animation)方向
      // $state.go('home');
    }

    function refreshLoginInfo() {
      //苹果审核 账号登录优先,其他手机优先
      $scope.isOneLogin =
        $rootScope.isIos && !$rootScope.iosPayOpen ? false : true;
      $scope.userInfo = _appv.currentUser;
      $scope.bookGold = _appv.bookGold;
      $scope.loginData = {};
      $scope.mobileLogin = {};
      $scope.isLogin = _appv.currentUser ? true : false;
    }

    function changeLogin() {
      !_app.isWeb && cordova.plugins.Keyboard.close();
      $scope.returnHeight && $('#loginModal').height($scope.returnHeight);
      $scope.isOneLogin = !$scope.isOneLogin;
    }

    function checkIosPage() {
      if (_app.isIos) {
        $scope.isIosPage = true;
      }
    }

    //发送验证码
    function sendCode() {
      //检查
      var mobile = $scope.mobileLogin.mobile;
      if (!mobile) {
        $ionicLoading.show({ template: '请输入手机号码！' });
        return;
      }
      if (!CheckInputUtil.mobile(mobile)) {
        return;
      }

      //发送验证码
      var type = 3; //一键登录类型
      $httpFactory.login.getCode(mobile, type).then(function (res) {
        if (res.data.result == 0) {
          $ionicLoading.show({ template: res.data.message });
          //倒计时
          var timeStop = $interval(function () {
            if ($scope.second <= 0) {
              $interval.cancel(timeStop);
              $scope.text = '发送';
              $scope.second = 60;
              $scope.color = {};
            } else {
              $scope.text = '已发送(' + $scope.second + ')';
              $scope.color = { color: '#959595' };
              $scope.second--;
            }
          }, 1000);
        } else {
          $ionicLoading.show({ template: res.data.message });
        }
      });
    }

    function checkOneLogin(mobile, code) {
      if (!mobile) {
        $ionicLoading.show({ template: '请输入手机号' });
        return;
      }
      if (!CheckInputUtil.mobile(mobile)) {
        return;
      }
      if (!code) {
        $ionicLoading.show({ template: '请输入验证码' });
        return;
      }
      if (code.match(' ')) {
        $ionicLoading.show({ template: '验证码错误：包含有非法空格字符' });
        return;
      }
      return true;
    }

    function checkNormalLogin(loginName, password) {
      if (!loginName) {
        $ionicLoading.show({ template: '请输入用户名' });
        return;
      }
      if (!password) {
        $ionicLoading.show({ template: '请输入密码' });
        return;
      }
      if (password.match(' ')) {
        $ionicLoading.show({ template: '密码错误：包含有非法空格字符' });
        return;
      }
      return true;
    }






    // $scope.privacyFlag = false;
    $scope.privacyShow = false;
    // 隐私政策
    $scope.privacyShowFunc = function () {
      $scope.privacyShow = true;
      $scope.localPravacy = localStorage.getItem("privacy");
    }
    $scope.privacyModel = function () {
      $scope.privacyShow = false;
      localStorage.setItem("privacy", 1)
      // if ($scope.privacyFlag) {
      //   $scope.privacyShow = false;
      //   localStorage.setItem("privacy", 1)
      // } else {
      //   alert("请先勾选条款")
      // }
    }
    $scope.closePrivacy = function () {
      $scope.privacyShow = false;
    }
    // 勾选隐私条款
    // $scope.checkPrivacy = function () {
    //   $scope.privacyFlag = !$scope.privacyFlag;
    // }
    $scope.localPravacy = localStorage.getItem("privacy");

    $scope.closeApp = function () {
      var confirmPopup = $ionicPopup.confirm({
        title: '提示',
        template: '不同意该条款将无法使用该应用',
        buttons: [
          { text: '取消' },
          {
            text: '<b>确认退出</b>',
            type: 'button-positive',
            onTap: function () {
              console.log("aaaa")
              navigator.app.exitApp();
            }
          },
        ]
      });
    }

    if (!$scope.localPravacy) {
      $scope.privacyShow = true;
    }





    //登录
    function doLogin() {
      //一键登录
      if ($scope.isOneLogin) {
        var mobile = $scope.mobileLogin.mobile;
        var code = $scope.mobileLogin.code;
        if (!checkOneLogin(mobile, code)) {
          return;
        }
        $httpFactory.login.oneLogin(mobile, code).then(function (res) {
          if (res.data.result == 0) {
            afterLogin(res);
          } else {
            $ionicLoading.show({ template: res.data.message });
          }
        });
      }
      //普通登录
      else {
        var loginName = $scope.loginData.loginName;
        var password = $scope.loginData.password;
        if (!checkNormalLogin(loginName, password)) {
          return;
        }
        var data = {
          content: JSON.stringify({
            loginName: loginName,
            // imei: getImei(),
            password: password
          })
        };
        $httpFactory.login.normalLogin(data).then(function (res) {
          if (res.data.result == 0) {
            afterLogin(res);
          } else {
            $ionicLoading.show({ template: res.data.message });
          }
        });
      }
    }




    function afterLogin(res) {
      $ionicLoading.show({ template: '登录成功！' });
      $scope.currentUser = res.data.object;
      _appv.currentUser = res.data.object;
      localStorageService.set('token', res.data.object.token); //token存入本地
      _appv.token = res.data.object.token;
      localStorageService.set('currentUser', res.data.object); //token存入本地
      delete RouteData.myTrolley; // 清空之前的购物车

      $rootScope.refresherExp && $rootScope.refresherExp(); // 如果已经进入过课件页,重新登录需要刷新数据

      // if(localStorageService.get('myBook')){
      //   $rootScope.myBook = localStorageService.get('myBook');
      $state.go('menu.main.exp');
      // }else{
      //   $state.go('book');
      // }
    }

    function initKeyboardListener() {
      if (_app.isIos) {
        window.addEventListener('native.keyboardshow', keyboardShowHandler);
        window.addEventListener('native.keyboardhide', keyboardHideHandler);
      }
    }

    function keyboardShowHandler(e) {
      // console.log('keyboard is show');
      $scope.returnHeight = $scope.returnHeight
        ? $scope.returnHeight
        : $('#loginModal').height();
      $('.third_div_all').css('display', 'none');
    }

    function keyboardHideHandler(e) {
      // console.log('keyboard is hide:'+new Date());
      if (!$('input').is(':focus')) {
        $timeout(function () {
          $('.third_div_all').css('display', '');
        }, 200);
      }
      $timeout(function () {
        $('ion-content').css('display', 'none');
        document.body.offsetWidth; // 在样式变化间加入计算,可强制提交之前的样式变化。否则浏览器会进行事务优化，事务前后无变化的不再重绘
        $('ion-content').css('display', '');
      }, 500);
    }

    function toForgetPwd() {
      $state.go('forgetPwd');
    }

    function loginQQ() {
      $ionicLoading.show({
        template:
          '<ion-spinner icon="ios-small"></ion-spinner><span>正在打开QQ...</span>',
        duration: 2000
      });
      $rootScope.auth_qq().then(function (res) {
        var qqLink = 'https://graph.qq.com/';
        var token = res.access_token;
        $http
          .get(qqLink + 'oauth2.0/me?access_token=' + token + '&unionid=1')
          .then(function (res) {
            //截取openid段数据
            res = JSON.stringify(res);
            var firstworld = res.indexOf('(');
            var lastworld = res.lastIndexOf(')');
            var data = JSON.parse(
              res.substring(firstworld + 1, lastworld).replace(/\\/g, '')
            );
            //赋值
            var access_token = token;
            var openid = data.openid;
            var app_id = data.client_id;
            var unionid = data.unionid;

            $http
              .get(
                qqLink +
                'user/get_user_info?access_token=' +
                access_token +
                '&oauth_consumer_key=' +
                app_id +
                '&openid=' +
                openid
              )
              .then(function (res) {
                var data = {
                  content: JSON.stringify({
                    nickName: res.data.nickname,
                    icon1: res.data.figureurl_qq_1,
                    sex: res.data.gender == '男' ? 'male' : 'female',
                    openId: openid,
                    unionid: unionid,
                    // imei: getImei(),
                    logo: 2,
                    role: 0
                  })
                };
                $httpFactory.login.thirdLogin(data).then(function (res) {
                  if (res.data.result == 0) {
                    afterLogin(res);
                  } else {
                    $ionicLoading({ template: res.data.message });
                  }
                });
              });
          });
      });
    }

    function loginWechat() {
      $ionicLoading.show({
        template:
          '<ion-spinner icon="ios-small"></ion-spinner><span>正在打开微信...</span>',
        duration: 2000
      });
      $rootScope.auth_wechat().then(function (response) {
        response = JSON.parse(response);
        var wechatLink = 'https://api.weixin.qq.com/sns';
        var APPID = _config.platform.wechat[_config.platform.code].appid;
        var CODE = response.code;
        var SECRET = _config.platform.wechat[_config.platform.code].secret;
        var authorization_code = 'authorization_code';
        $http
          .get(
            wechatLink +
            '/oauth2/access_token' +
            '?appid=' +
            APPID +
            '&secret=' +
            SECRET +
            '&code=' +
            CODE +
            '&grant_type=' +
            authorization_code
          )
          .then(function (res) {
            var token = res.data.access_token;
            var openId = res.data.openid;
            var unionid = res.data.unionid;

            $http
              .get(
                wechatLink +
                '/userinfo?access_token=' +
                token +
                '&openid=' +
                openId
              )
              .then(function (res) {
                var data = {
                  content: JSON.stringify({
                    nickName: res.data.nickname,
                    icon1: res.data.headimgurl,
                    sex: res.data.sex == '0' ? 'male' : 'female',
                    openId: res.data.openid,
                    unionid: unionid,
                    // imei: getImei(),
                    logo: 1,
                    role: 0
                  })
                };
                $httpFactory.login.thirdLogin(data).then(function (res) {
                  if (res.data.result == 0) {
                    afterLogin(res);
                  } else {
                    $ionicLoading.show({ template: res.data.message });
                  }
                });
              });
          });
      });
    }
  }
})();
