(function (){
  'use strict';

  angular
    .module('starter')
    .controller('ResetCtrl',MainCtrl);

  function MainCtrl($scope,$ionicHistory,RouteData,$httpFactory,$ionicLoading,$state){
    {
      var mobile = RouteData.resetMobile;
      var code = RouteData.resetCode;
      $scope.navBack = navBack;
      $scope.resetPassword = resetPassword;
      $scope.data={};
    }

    function navBack(){
      $ionicHistory.goBack();
    }

    function resetPassword(){
      var password = $scope.data.password;
      var passwordAgain = $scope.data.passwordAgain;

      if(!password && !passwordAgain){
        $ionicLoading.show({template:'请输入密码'});
        return;
      }
      if(!RegExp("^[0-9a-zA-Z]{6,12}$").test(password)){
        $ionicLoading.show({template:'格式错误：请输入6~12位的数字或字母'});
        return false;
      }
      if(password != passwordAgain){
        $ionicLoading.show({template:'两次输入密码不一致'});
        return;
      }

      var data = {
        content: JSON.stringify({
          password: password,
          mobile: mobile,
          randomCode: code
        })
      };
      $httpFactory.login.resetPassword(data).then(function(res){
        if(res.data.result == 0){
          $ionicLoading.show({template:res.data.message});
          $ionicHistory.goBack(-2);
          // $state.go('login');
        }else{
          $ionicLoading.show({template:res.data.message});
        }
      });
    }

  }
})();
