(function () {
    'use strict';

    angular
        .module('starter')
        .controller('ChapterCtrl', MainCtrl);

    function MainCtrl($scope, RouteData, $ionicHistory, $httpFactory, $ionicLoading, $ionicNavBarDelegate,$cordovaFile,$cordovaFileTransfer,$timeout,localStorageService ) {
        {
            var user = _appv.currentUser;
            var token = _appv.token;
            var rootPath;      //设置缓存目录
            _app.isAndroid && (rootPath = cordova.file.externalDataDirectory);      //安卓目录
            _app.isIos && (rootPath = cordova.file.documentsDirectory);          //ios目录
            $scope.chooseChapterInfo = RouteData.ChooseChapterInfo;
            $scope.navBack = navBack;//回退
            $scope.play = play;//播放
            $scope.f_openPoint = f_openPoint;//打开知识点

            chapterKnowPoint();//获取课件下面的知识点、
            !_app.isWeb && initVideoCache();
            initVideoListion();
        }

        function initVideoCache(){
          //获取缓存视频
          var knowPoint = localStorageService.get('chapterKnowPoint'+$scope.chooseChapterInfo.expId);
          if(knowPoint && knowPoint.resList[0] && knowPoint.resList[0].url){
			  var videoUrl = knowPoint.resList[0].url;
	          var videoNameList = videoUrl.split('/');
	          var videoName = videoNameList[videoNameList.length-1];
	          $cordovaFile.checkFile(rootPath,'expVideo/lock_'+videoName).then(function(res){
	            $cordovaFile.removeFile(rootPath, 'expVideo/lock_' + videoName).then(function(){                     //有锁文件--删除锁文件
	              $cordovaFile.removeFile(rootPath, 'expVideo/' + videoName).then();                                   //有锁文件--删除视频原文件
	            });
	          },function(){
	            $cordovaFile.checkFile(rootPath,'expVideo/'+videoName).then(function(res){
	              $scope.localVideoUrl = res.nativeURL;
	            })
	          });
          }
        }

        function navBack() {
            $ionicHistory.goBack();
        }

        function chapterKnowPoint() {
            $httpFactory.exp.chapterKnowPoint(user.userId, $scope.chooseChapterInfo.expId).then(function (res) {
                console.log(res);
                if (0 === res.data.result) {
                    $scope.chapterKnowPoints = res.data.object;
                    localStorageService.set('chapterKnowPoint'+$scope.chooseChapterInfo.expId,$scope.chapterKnowPoints);
                } else {
                    $ionicLoading.show({template: res.data.message});
                }
            })
        }

        /**
         * 播放
         */
        function play(knowPoint) {
            !_app.isWeb && cacheVideo(knowPoint);     //app端，缓存视频到本地文件夹

            var el_video = document.querySelector('video');
            if (_app.isIos) {
                el_video.play();
                document.querySelector('.banner_pic').style.display = 'none';
                document.querySelector('.playIcon').style.display = 'none';
                el_video.style.display = 'block';
            } else {
                el_video.play();
                document.querySelector('.banner_pic').style.display = 'none';
                document.querySelector('.playIcon').style.display = 'none';
                el_video.style.display = 'block';
            }
        }

        function cacheVideo(knowPoint){
          var videoUrl = knowPoint.resList[0].url;
          var videoNameList = videoUrl.split('/');
          var videoName = videoNameList[videoNameList.length-1];

          $cordovaFile.checkDir(rootPath,'expVideo').then(dirSuccess,dirFault);
          //有目录
          function dirSuccess(){
            $cordovaFile.checkFile(rootPath,'expVideo/lock_'+videoName).then(lockFileSuccess,lockFileFault);    //检测锁文件
          }
          //无目录
          function dirFault(){
            $cordovaFile.createDir(rootPath,'expVideo',true).then(dirSuccess,fileFault);                        //创建目录
          }
          function lockFileSuccess(){
            $cordovaFile.removeFile(rootPath, 'expVideo/lock_' + videoName).then(function(){                     //有锁文件--删除锁文件
              $cordovaFile.removeFile(rootPath, 'expVideo/' + videoName).then(fileFault);                                   //有锁文件--删除视频原文件
            });
          }
          function lockFileFault(){
            $cordovaFile.checkFile(rootPath,'expVideo/'+videoName).then(fileSuccess,fileFault);                  //无锁文件--检测视频
          }
          //有视频
          function fileSuccess(){

          }
          //无视频
          function fileFault(){
            var url = videoUrl;     //视频web地址
            var targetPath = rootPath + 'expVideo/' + videoName;
            var options = {};
            var trustHosts = true;
            $cordovaFile.createFile(rootPath,'expVideo/lock_' + videoName).then(function(){                     //创建锁文件
              $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {         //缓存下载文件
                // Success!
                $cordovaFile.removeFile(rootPath, 'expVideo/lock_' + videoName).then(function () {
                  console('删除锁文件')
                });
              },function(err){
                alert("文件缓存失败:"+JSON.stringify(err))
              },function(progress){
                $timeout(function () {
                  var downloadProgress = parseInt((progress.loaded / progress.total) * 100);
                  downloadProgress % 10 == 0 && console.log(downloadProgress);
                });
              });
            });
          }
        }

        /**
         * 打开知识点
         * @param point
         */
        function f_openPoint(point, index) {
             $httpFactory.sys.getVersion().then(function (res) {
                 f_openPoint_hanlder(point, index);
             }).catch(function (e) {
                $ionicLoading.show({template: "网络连接失败 ,请检查网络"});
             });
        }

        /*
         * 打开窗口，关闭窗口
         * */
        function f_openPoint_hanlder(point, index) {

            !_app.isWeb && $ionicNavBarDelegate.showBar(false);
            /*if (!navigator.onLine) {
              $ionicLoading.show({template: "网络连接失败 ,请检查网络"});
              return;
            }*/
            if(!!point.knowExpList[0].exp && !!point.knowExpList[0].exp.webURL){
                var webUrl = point.knowExpList[0].exp.webURL;                     //本地存储地址
            }else{
                $ionicLoading.show({template: "暂无资源"});
                return ;
            }

            // var webUrl = point.knowExpList[0].exp.webURL;     //后台提取的地址

            // $ionicNavBarDelegate.showBar(false);

            if (_app.isWeb) {
                window.open(webUrl, '_blank', 'location=no,immersion=yes,toolbar=no');
                return;
            }

            var immersion = '';
            if (_app.isAndroid && navigator.userAgent.indexOf('PAD') < 0) {
                immersion = ',immersion=yes';
            }
            //,hidden=yes
            var web = window.open(webUrl, '_blank', 'location=no,toolbar=no,hidden=yes' + immersion); // cordova-plugin-inappbrowser
            !_app.isWeb && window.screen.orientation.lock("landscape");// 横屏进入,避免自适应排版问题

            // 10s如还没有打开,则恢复横屏.
            setTimeout(function () {
                if (!web.isShow) {
                    web.close();
                    !_app.isWeb && window.screen.orientation.lock("portrait");// 恢复竖屏
                    web.isClose = true;
                }
            }, 10 * 1000)

            if (web) {
                web.addEventListener('loadstart', iabLoadStart);             //html页面加载前进行iabLoadStart函数操作
                web.addEventListener('loadstop', isLoadstop);             //html页面加载后进行iabLoadStop 函数操作
                // web.addEventListener('loaderror', iabLoadError);           //html页面加载错误时进行iabLoadError 函数操作
                web.addEventListener('exit', iabClose);                      //html页面关闭后进行iabClose 函数操作
                web.addEventListener('mycmd', mycmd);                      //html页面关闭后进行iabClose 函数操作

                $scope.web = web;// 绑定到页面提供页面关闭功能
            }

            var startTime;

            function iabLoadStart(event) {
                // window.screen.orientation.lock("landscape");
                startTime = +new Date();
            }

            function isLoadstop() {
                isLoadstop_handle();
            }

            function isLoadstop_handle() {
                if (web.isClose) {
                    return;
                }

                $ionicNavBarDelegate.showBar(true);
                $scope.$apply();

                web.show();// 显示窗口
                web.isShow = true;
                document.querySelector('video').pause();// 暂停视频
                // setTimeout(function(){isAllowChoice = true},2000);
            }

            function iabClose(event) {
                !_app.isWeb && window.screen.orientation.lock("portrait");// 恢复竖屏
            }

            function mycmd(cmd) {
                var cmd = cmd.args.split(':');

                switch (cmd[0]) {
                    case 'close':
                        web.close();
                        web = null;
                        return true;
                    case 'loadstop':
                        isLoadstop_handle();
                        return true;
                }
            }

            // var expHanler;
            // document.addEventListener("pause", function () {
            //   console.log('pause');
            //   expHanler = true;
            // }, false);
            //
            // document.addEventListener("resume", function () {
            //   console.log('resume');
            //   expHanler && iabClose();// 回到客户端,调用实验关闭事件处理,恢复竖屏
            //   expHanler == false;// 执行完毕
            // }, false);


        }


        function initVideoListion(){
            $scope.$watch('$viewContentLoaded', function () {
                var screen_change_events = "webkitfullscreenchange mozfullscreenchange fullscreenchange MSFullscreenChange";
                $(document).on(screen_change_events, function () {
                    console.log('change', document['webkitIsFullScreen'], screen_change_events);
                    if (document['webkitIsFullScreen']) {
                        !_app.isWeb && window.screen.orientation.lock("landscape");// 横屏
                    } else {
                        !_app.isWeb && window.screen.orientation.lock("portrait");// 恢复竖屏
                    }
                });

                // 二维码初始化
                // new QRCode(document.getElementById("qrcode"), "http://baidu.com");
            });
        }

    }
})();
