(function () {
  'use strict';

  angular
    .module('starter')
    .controller('ExpCtrl', MainCtrl);

  function MainCtrl($scope, $httpFactory, localStorageService, PaymentFactory, $rootScope, $state, RouteData, $ionicScrollDelegate, $cordovaAppVersion, $ionicPopup, $ionicLoading) {
    {
      $scope.isIOS = _app.isIos;
      $scope.ios_isPayChoose = $rootScope.ios_isPayChoose;
      $scope.platform = _config.platform;
      $scope.qqGroup = _config.platform.number == 2 ? "生物" : "化学";

      initExpList();
      $rootScope.refresherExp = refresherExp;
      // $scope.openBook = openBook;
      $scope.toShop = toShop;
      $scope.openApp_web = openApp_web;
      // checkOldUser();         //老用户资格获取
      $scope.toReward = toReward;
      $scope.payUser = payUser;//判断是否是付费用户

      var userInfo = window._appv.currentUser;

      $scope.paySeclectType = paySeclectType;
    }

    function initExpList() {
      $rootScope.expLoading = true;
      var book = $rootScope.myBook ? $rootScope.myBook : localStorageService.get('myBook');
      $scope.book = book;
      $rootScope.expList = localStorageService.get("exp_" + book.id);
      if ($rootScope.expList) {
        $rootScope.noLogind = true;
        $rootScope.expLoading = false;
      }

      $httpFactory.exp.expList(0, _config.platform.number).then(function (result) {
        $rootScope.expLoading = false;
        if (result.status == -1) {
          $rootScope.networkError = true;
        } else {
          $rootScope.networkError = false;
          $rootScope.expList = result.data.object;// 所有实验
          $rootScope.allExpPrice = 0;
          for (var i in result.data.object) {
            $rootScope.allExpPrice = $rootScope.allExpPrice + result.data.object[i].price;
          }
          !!result.data.object && localStorageService.set("exp_" + book.id, result.data.object);
        }
      });
      //本册书的价格(没经过选择哪一册，直接进入书本)
      if (!$scope.openBook) {
        var level, knowId, userId, type;
        level = 0;
        userId = _appv.currentUser.userId;
        type = 2;
        $httpFactory.product.productList(level, null, userId, type).then(function (res) {
          if (res.data.result == 0) {
            $scope.openBook = res.data.object[0];
          }
        })
      }
      $scope.$broadcast('scroll.refreshComplete');
    }

    function refresherExp() {
      initExpList();
      // checkOldUser();
      userInfo = window._appv.currentUser;
    }

    function checkOldUser() {
      _appv.currentUser && _appv.currentUser.userId != -1 && $httpFactory.user.checkOldUser(_appv.currentUser.userId).then(function (res) {
        if (res.data.result == 0) {
          $scope.oldUser = res.data.object;
          RouteData.oldUser = $scope.oldUser;
        }
      });
    }

    // function openBook() {
    //     $ionicSideMenuDelegate.toggleLeft();
    // }

    function toShop() {
      payForBook();
    }

    function openApp_web(exp) {
      // $httpFactory.sys.sysConfig('app').then(function (res) {
      openApp_web_handle(exp);
      // }).catch(function (e) {
      //     $ionicLoading.show({template: "网络连接失败 ,请检查网络"});
      // });
    }

    function openApp_web_handle(exp) {
      $scope.openExp = exp;
      // RouteData.exp_place = $ionicScrollDelegate.$getByHandle('expScroll').getScrollPosition().top;   //记录锚点位置

      //未订购实验时
      if (exp.status == _app.exp_order_no) {

        //如果为游客
        if (userInfo.userId == -1) {
          $state.go('login');
          return;
        }
        //本册书的价格(没经过选择哪一册，直接进入书本)
        if (!$scope.openBook) {
          var level, knowId, userId, type;
          level = 0;
          userId = _appv.currentUser.userId;
          type = 2;
          $httpFactory.product.productList(level, null, userId, type).then(function (res) {
            if (res.data.result == 0) {
              $scope.openBook = res.data.object[0];
            }
          })
        }
        //老用户通道
        if ($scope.oldUser && $scope.oldUser.isOldUser == 1) {
          $scope.oldUserPopup = $ionicPopup.show({
            cssClass: 'myPopup',
            templateUrl: 'app/modal/oldUser.html',
            scope: $scope
          });
          return;
        }
        //新用户通道
        RouteData.productPay = {
          productType: _app.orderType_exp,
          content: [{
            productCode: exp.productCode,
            productName: exp.expName
          }],
          price: exp.price,
          img: {
            title: exp.expName,
            url: exp.picURL2
          }
        };

        $scope.myPopup = $ionicPopup.show({
          cssClass: 'myPopup',
          templateUrl: 'app/main/exp/exp_select.html',
          scope: $scope
        });
        return;
      }

      RouteData.ChooseChapterInfo = exp;
      $state.go("menu.chapter");

      /* var immersion = '';
       if (_app.isAndroid && navigator.userAgent.indexOf('PAD') < 0) {
       immersion = ',immersion=yes';
       }
       var web = window.open(exp.mobileUrl, '_blank', 'location=no,toolbar=no' + immersion);// 依赖插件 cordova-plugin-inappbrowser

       window.screen.orientation.lock("landscape");// 横屏进入,避免自适应排版问题

       web.addEventListener('loadstart', iabLoadStart);          //html页面加载前进行iabLoadStart函数操作
       //web.addEventListener('loadstop', iabLoadStop);            //html页面加载后进行iabLoadStop 函数操作
       //web.addEventListener('loaderror', iabLoadError);          //html页面加载错误时进行iabLoadError 函数操作
       web.addEventListener('exit', iabClose);                    //html页面关闭后进行iabClose 函数操作
       web.addEventListener('mycmd', mycmd);

       function iabLoadStart(event) {
       console.log("webAppOpening....")
       //window.screen.orientation.lock("landscape");
       }

       function iabClose(event) {
       window.screen.orientation.lock("portrait");
       }

       function mycmd(cmd) {
       var cmd = cmd.args.split(':');
       switch (cmd[0]) {
       case 'close':
       web.close();
       return true;
       }
       }*/
    }

    function paySeclectType(type) {
      $scope.myPopup.close();
      //是否登录
      if (userInfo.userId == -1) {
        $state.go('login');
        return;
      }

      if (type == 0) {
        payForExp();
      } else {
        payForBook();
      }
    }

    function payForExp() {
      var productPay = {
        productType: _app.orderType_exp,
        payNameLeft: $scope.openExp.expName,
        payNameRight: false,
        price: $scope.openExp.price,
        discount: "0.00",
        content: [{
          productCode: $scope.openExp.productCode,
          productName: $scope.openExp.expName
        }],
      }

      // 打开选择付费方式
      PaymentFactory.openPayChoose($scope, productPay, function () {
        $scope.myPopup.close();
      }, function () {
        $scope.myPopup.close();// 支付失败,关闭弹窗
      });
    }

    function payForBook() {
      var productPay = {
        productType: _app.orderType_book,
        payNameLeft: $scope.openBook.name,
        payNameRight: false,
        price: $scope.openBook.price,
        discount: parseInt($rootScope.allExpPrice - $scope.openBook.price),
        content: [{
          productCode: $scope.openBook.code,
          productName: $scope.openBook.name
        }],
      }

      // 打开选择付费方式
      PaymentFactory.openPayChoose($scope, productPay, function () {
        $scope.myPopup.close();
      }, function () {
        $scope.myPopup.close();// 支付失败,关闭弹窗
      });
    }

    function toReward() {
      $scope.oldUserPopup.close();
      $httpFactory.exp.findProduct($scope.openExp.expId, _appv.currentUser.userId, _appv.token).then(function (res) {
        if (res.data.result == 0) {
          RouteData.openProduct = res.data.object[0];
          toShop();
        }
      });
    }

    //一键加群
    function joinQQGroup() {
      if(_app.isWeb){
        return;
      }
      var key = 'joinQQGroup_' + _config.platform.code;
      $httpFactory.sys.sysConfig(key).then(function (res) {
        if (res.data.result == 0) {
          var joinQQGroupJson = JSON.parse(res.data.object[0].value)
          if (_app.isAndroid) {
            JoinQQGroup.open({key: joinQQGroupJson.android.key});
          } else if (_app.isIos) {
            JoinQQGroup.open({uin: joinQQGroupJson.ios.uin, key: joinQQGroupJson.ios.key});
          }
        }
      });
    }

    function payUser() {
      if (!userInfo) {
        $state.go('login');
        return;
      }
      if (userInfo.isPayUser != 1) {
        $scope.myPopup = $ionicPopup.show({
          cssClass: 'myPopup',
          templateUrl: 'app/ispay/payUser.html',
          scope: $scope
        });

        //$ionicLoading.show({template:'<div><button ng-click="loadingHide()"></button><img src="../../img/icon.png"></div>',duration:''});
        return;
      }
      joinQQGroup();
    }
  }
})();
