(function () {
  'use strict';

  angular
    .module('starter')
    .controller('PracticeCtrl',MainCtrl);

  function MainCtrl($scope,$httpFactory,$ionicSideMenuDelegate,$rootScope,localStorageService,RouteData,$state,$timeout) {
    {
      var book;
      initData();
      $scope.openBook = openBook;
      $scope.openSection = openSection;
      $scope.toQuestion = toQuestion;
      $scope.getProgessNum = getProgessNum;
      $rootScope.refresherPractice = refresherPractice;
    }

    function refresherPractice(){
      initData();
    }

    function listienOnLoaded() {
      //监控加载动作的三种方法
      //第一种：接口数据调用前
      // $scope.$watch('$viewContentLoaded', function () {
      //   $timeout(function(){
      //     initView();         //打开上一次浏览的章节
      //   },1000)
      // });
      //第二种：html加载后，$scope数据插入前
      // $scope.$on('$ionicView.afterEnter', function() {
      //   initView();
      // }, false)
      //第三种：html加载后，$scope数据插入后数据有变化时调用
      $scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
        initView();
      });
    }

    function initView(){
      $scope.sectionRead = RouteData.knowPoint?RouteData.knowPoint:localStorageService.get('sectionRead');
      if($scope.sectionRead){
        for(var i=0;i<$rootScope.chapterList.length;i++){
          //打开章练习列表
          if($scope.sectionRead.lever ==_app.chapter){
            if($rootScope.chapterList[i].id==$scope.sectionRead.id){
              $scope.openIndex = i;
              open(i);
              break;
            }
          }
          //通过节，找到并打开章练习列表
          else if($scope.sectionRead.lever ==_app.section){
            for(var j=0;j<$rootScope.chapterList[i].sectionList.length;j++){
              if($rootScope.chapterList[i].sectionList[j].id==$scope.sectionRead.id){
                $scope.openIndex = i;
                open(i);
                break;
              }
            }
          }
        }
      }
    }

    function openBook(){
      $ionicSideMenuDelegate.toggleLeft();
    }

    function initData(){
      // 初始化练习
      book = $rootScope.myBook?$rootScope.myBook:localStorageService.get('myBook');
      // $scope.practice = localStorageService.get("practice_" + book.id);
      !!$scope.practice && ($rootScope.noLogind = true);
      $rootScope.practiceLoading = true;     //打开loading动画
      //未登录状态下
      if(_appv.currentUser.userId == -1){
        $httpFactory.practice.chapter(-1,book.id).then(function (result) {
          $rootScope.practiceLoading = false;     //关闭loading动画
          if(result.status == -1){
            $scope.networkError = true;
          }else{
            $scope.networkError = false;
            $scope.practice = result.data.object;
            for(var i=0;i<$scope.practice.length;i++){
              var logJson = localStorageService.get("exerciseLog"+$scope.practice[i].id);
              if(logJson){
                var logObj = eval("["+logJson+"]");
                var trueNum=0;
                if($scope.practice[i].lever==1){
                  trueNum = logObj[0].list.length;
                }
                else if($scope.practice[i].lever==2){
                  for(var j= 0;j<logObj[0].list.length;j++){
                    if(logObj[0].list[j].isTrue==1){
                      trueNum+=1;
                    }
                  }
                }
                $scope.practice[i].trueNum=trueNum;
              }
            }
            getChapter($scope.practice);
            localStorageService.set("practice_" + book.id, result.data.object);
            listienOnLoaded();
          }
        });
      }
      //登录状态下
      else{
        $httpFactory.practice.chapter(_appv.currentUser.userId,book.id).then(function (result) {
          $rootScope.practiceLoading = false;     //关闭loading动画
          if(result.status == -1){
            $rootScope.networkError_practice = true;
          }else {
            $rootScope.networkError_practice = false;
            $rootScope.practiceList = result.data.object;
            localStorageService.set("practice_" + book.id, result.data.object);
            getChapter($rootScope.practiceList);
            listienOnLoaded();
          }
        });
      }
      $scope.$broadcast('scroll.refreshComplete');
    }

    function getChapter(practice){
      $rootScope.chapterList = [];
      //获取所有章
      for(var i=0;i<practice.length;i++){
        if(practice[i].lever==1){
          practice[i].chapter = practice[i].name.split(' ')[0];
          practice[i].chapterName = practice[i].name.split(' ')[1];
          ($rootScope.chapterList.push(practice[i]));
        }
      }
      //获取章里面所有节
      for(var i=0;i<$scope.chapterList.length;i++){
        $scope.chapterList[i].sectionList = [];
        for(var j=0;j<practice.length;j++){
          practice[j].lever==2 &&
          practice[j].parent_id==$scope.chapterList[i].id &&
          !practice[j].name.match("（综合）") &&
          !practice[j].name.match("中考要点总结") &&
          $rootScope.chapterList[i].sectionList.push(practice[j]);
        }
      }
    }

    function openSection(index){
      //关闭上次打开的章节
      if($scope.openIndex || $scope.openIndex==0){
        var oldIndex = $scope.openIndex;
        var opened = $('.section_div:eq('+oldIndex+')').height()>0;    //下拉菜单是否已打开
        if(opened){
          $('.section_div:eq('+oldIndex+')').css('height',0).on("transitionend", function(){
            if($('.section_div:eq('+oldIndex+')').height()==0){
              $('.chapter_div:eq('+oldIndex+')').css('border-radius','');
              $('.chapter_div:eq('+oldIndex+')').css('background','');
            }
          });
          $('.item_icon:eq('+$scope.openIndex+')').css('transform','rotate(0deg)');
        }
      }
      //记录本次打开的章节序列
      $scope.openIndex = index;
      open(index);
    }
    function open(index){
      //打开本次点击的章节
      var opened = $('.section_div:eq('+index+')').height()>0;    //下拉菜单是否已打开
      var itemNum =$('.section_div:eq('+index+') .item').length-1;
      // var height = 'calc('+ itemNum*10 +'vh + 95px)';
      // var height = window.screen.height*itemNum*12/100+94+'px';    //计算节div高度
      var height = $('ion-content.page_practice').parent().height()*itemNum*12/100+94+'px';    //计算节div高度
      if(!opened){
        // $scope.chapter_div = {'border-radius':'4vw 4vw 0px 0px','background':'#e5e5e5'};
        // $scope.section_div = {'height':height};
        // $scope.item_icon = {'transform':'rotate(180deg)'};
        $('.chapter_div:eq('+index+')').css('border-radius','4vw 4vw 0px 0px');           //方形边框变圆角
        $('.chapter_div:eq('+index+')').css('background','#e5e5e5');                        //白色背景变灰色
        $('.section_div:eq('+index+')').css('height',height);                                 //高度变化
        $('.item_icon:eq('+index+')').css('transform','rotate(180deg)');                    //角标旋转180°
      }else{
        $('.section_div:eq('+index+')').css('height',0).on("transitionend", function(){
          if($('.section_div:eq('+index+')').height()==0){
            $('.chapter_div:eq('+index+')').css('border-radius','');
            $('.chapter_div:eq('+index+')').css('background','');
          }
        });
        $('.item_icon:eq('+index+')').css('transform','rotate(0deg)');
      };
    }

    function toQuestion(knowPoint){
      RouteData.knowPoint = knowPoint;
      localStorageService.set('sectionRead',knowPoint);
      $state.go('menu.question');
    }

    function getProgessNum(chapter){
      //return 100;
      if((chapter.trueNum/chapter.totalNum) >= 1){
        return 100;
      }else{
        return Math.floor(chapter.trueNum/chapter.totalNum*100);
      }
    }
  }
})();
