(function(){
  'use strict';

  angular
    .module('starter')
    .controller('ProductCtrl',MainCtrl);

  function MainCtrl($scope,$httpFactory,$ionicHistory,$ionicPopup,RouteData,$ionicLoading,$state,localStorageService,$rootScope){
    {
      initProductList();
      $scope.initProductList = initProductList;
      $scope.navBack = navBack;
      $scope.toProductInfo = toProductInfo;
      initOpenProduct();
      $scope.addToTrolley = addToTrolley;
      $scope.myTrolley = RouteData.myTrolley ? RouteData.myTrolley : [];
      $scope.toTrolleyInfo = toTrolleyInfo;
      $scope.oldUser = RouteData.oldUser?RouteData.oldUser:{};
      $scope.getReward = getReward;
    }

    function initOpenProduct(){
      RouteData.openProduct && toProductInfo(RouteData.openProduct);
      delete RouteData.openProduct;
    }

    function navBack(){
      $ionicHistory.goBack();
    }

    function initProductList(){
      var level,knowId,userId,type;
      level = 0;
      userId = _appv.currentUser.userId;
      type = 2;
      $scope.row = [];
      $httpFactory.product.productList(level,null,userId,type).then(function(res){
        if(res.status == -1){
          $scope.networkError = true;
        }else{
          $scope.networkError = false;
          if(res.data.result == 0){
            $scope.productList = res.data.object;
            var page = 0;
            $scope.row[page]=[];
            for(var i=0;i<$scope.productList.length;i++){
              if(i!=0 && i%3==0){
                page++;
                $scope.row[page]=[];
              }
              $scope.row[page].push($scope.productList[i]);
            }
          }
        }
      });
    }

    function toProductInfo(product){
      $scope.product = product;
      $httpFactory.product.expList(product.code).then(function(res){
        if(res.data.result==0){
          $scope.product.payExpList = res.data.object;
          $scope.productPopup = $ionicPopup.show({
            cssClass:'myPopup',
            templateUrl:'app/product/productInfo.html',
            scope:$scope
          });
        }else{
          $ionicLoading.show({template:'获取不到产品详细信息'});
        }
      });
    }

    function addToTrolley(product){
      if(product.status != 1){
        $ionicLoading.show({template:'该课件已购买或无需购买'});
        return;
      }
      for(var i=0;i<$scope.myTrolley.length;i++){
        if($scope.myTrolley[i].code == product.code){
          break;
        }
      }
      if(i>=$scope.myTrolley.length){
        $scope.myTrolley.push(product);
        RouteData.myTrolley = $scope.myTrolley;
        // $ionicLoading.show({template:'添加成功',duration:500});
      }else{
        $ionicLoading.show({template:'已加入购物车'});
      }
      $scope.productPopup.close();
    }

    function toTrolleyInfo(){
      if(RouteData.myTrolley && RouteData.myTrolley.length!=0){
        $state.go('menu.trolley');
      }else{
        $ionicLoading.show({template:'购物车为空'});
      }
    }
    function getReward(product){
      $httpFactory.user.getReward(_appv.currentUser.userId,product.code,_appv.token).then(function(res){
        $rootScope.refresherExp();
        $ionicLoading.show({template:res.data.message});
        $scope.productPopup.close();
        initProductList();
      });
    }
  }
})();
