(function(){
  'use strict';

  angular
    .module('starter')
    .controller('TrolleyCtrl',MainCtrl);

  function MainCtrl($scope,$ionicHistory,RouteData,$state,$ionicLoading){
    {
      var content;
      $scope.productList  = RouteData.myTrolley;
      initPrice();
      $scope.navBack = navBack;
      $scope.open = open;
      $scope.deleteProduct = deleteProduct;
      $scope.pay = pay;
    }

    function initPrice(){
      var originalPrice=0;        //原价归零
      var price=0;                //现价归零
      content = [];              //收集ProductCode为支付做准备
      for(var i=0;i<$scope.productList.length;i++){
        originalPrice = originalPrice + $scope.productList[i].originalPrice;
        price =  price + $scope.productList[i].price;
        content.push({
          productCode:$scope.productList[i].code,
          productName:$scope.productList[i].name
        });
      }
      $scope.originalPrice = originalPrice;
      $scope.price = price;
    }

    function navBack(){
      $ionicHistory.goBack();
    }

    function open(index){
      var itemNum = $('.down_div:eq('+index+') .chapter_div').length;
      var height = itemNum*7+3+'vh';
      var isOpened = $('.down_div:eq('+index+')').height()>0;
      if(isOpened){
        $('.down_div:eq('+index+')').css('height',0);
        $('.ion-chevron-down:eq('+index+')').css('transform','rotate(0deg)');
      }else{
        $('.down_div:eq('+index+')').css('height',height);
        $('.ion-chevron-down:eq('+index+')').css('transform','rotate(180deg)');
      }
    }

    function deleteProduct(index){
      $scope.productList.splice(index,1);
      initPrice();
    }

    function pay(){
      if(!$scope.productList || $scope.productList.length==0){
        $ionicLoading.show({template:'购物车没有商品'});
        return;
      }
      RouteData.productPay = {
        price:$scope.price,
        content:content,
        productType:_app.orderType_book
      }
      $state.go('menu.pay');
    }
  }
})();
