(function(){
  'use strict';

  angular
    .module('starter')
    .controller('QuestionCtrl',MainCtrl);

  function MainCtrl($scope,$httpFactory,RouteData,$ionicHistory,$ionicLoading,$state,localStorageService,$rootScope){
    {
      var userId = _appv.currentUser&&_appv.currentUser.userId ? _appv.currentUser.userId : -1;
      var knowPoint = RouteData.knowPoint;
      var sum = 5;        //随机抽题数
      initQuestion();
      $scope.navBack = navBack;
      $scope.next = next;
      $scope.index=0;
    }

    function navBack(){
      $ionicHistory.goBack();
    }

    function initQuestion(){
      var data = {
        userId : _appv.currentUser?_appv.currentUser.userId:-1
      }
      $httpFactory.practice.get_question(knowPoint.id,sum,data).then(function(res){
        if(res.data.result == 0){
          $scope.questionList = res.data.object;
          show($scope.index)
        }
      });
    }

    function show() {
      if ($scope.questionList.length > $scope.index) {
        $scope.questionShow = $scope.questionList[$scope.index];// 下一题
      }
    }

    function next(answer){
      $scope.questionList[$scope.index].isCorrect = checkAnswer(answer.id);    //记录答题是否正确
      $scope.questionList[$scope.index].answer = answer.id;                     //记录用户选择

      //不是最后一题
      if($scope.index+1<$scope.questionList.length){
        $scope.index = $scope.index +1;
        show();
      }
      //最后一题时
      else{
        //答题记录
        var content = {
          knowId:knowPoint.id,
          list:[]
        }
        for (var i=0;i<$scope.questionList.length;i++){
          content.list.push({
            questionId:$scope.questionList[i].id,
            result: $scope.questionList[i].answer,
            isTrue: $scope.questionList[i].isCorrect ? 1 : 0
          })
        }
        //已登录状态，提交到服务器
        if(_appv.currentUser.userId != -1){
          var data = {
            token:localStorageService.get('token'),
            content:JSON.stringify(content)
          }

          $httpFactory.question.save_scores(userId,data).then(function(res){
            if(res.data.result == 0){
              $rootScope.refresherPractice();       //刷新练习页成绩
              console.log('成绩提交成功');
            }else{
              $ionicLoading.show({template:res.data.message});
              if(res.data.message.concat('重新登录')){
                $state.go('login');
              }
            }
          });
        }
        //未登录状态，保存到本地
        else{
          $rootScope.refresherPractice();       //刷新练习页成绩
          /*节目录成绩保存*/
          if(knowPoint.lever==_app.section){
            localStorageService.set("exerciseLog"+knowPoint.id,JSON.stringify(content));     //节目录下：本地保存成绩，exerciseLog+知识点Id唯一标识，每次提交覆盖上一次
          }
          /*章目录成绩保存*/
          else if(knowPoint.lever==_app.chapter){
            var exerciseLog = localStorageService.get("exerciseLog"+knowPoint.id);  //取本地数据
            //有本地成绩
            if(exerciseLog){
              var oldList = eval("["+exerciseLog+"]")[0].list;         //转成obj数据对象
              for(var i=0;i<content.list.length;i++){
                var exercise = content.list[i];
                if(exercise.isTrue){
                  for(var j= 0;j<oldList.length;j++){
                    if(exercise.questionId==oldList[j].questionId){
                      break;
                    }
                  }
                  if(j>=oldList.length){
                    oldList.push(exercise);
                    content.list = oldList;
                    localStorageService.set("exerciseLog"+knowPoint.id,JSON.stringify(content));
                  }
                }
              }
            }
            //没有本地成绩
            else{
              var list = new Array();
              for(var i=0;i<content.list.length;i++){
                var exercise = content.list[i];
                if(exercise.isTrue){
                  list.push(exercise);
                }
              }
              content.list=list;
              localStorageService.set("exerciseLog"+knowPoint.id,JSON.stringify(content));
            }
          }
        }

        //to查看成绩页面
        RouteData.questionList = $scope.questionList;
        $state.go('menu.questionFinish');
      }
    }

    function checkAnswer(answerId){
      if($scope.questionList[$scope.index].question.result == answerId){
        return true;
      }
      else{
        return false;
      }
    }
  }
})();
