(function(){
  'use strict';

  angular
    .module('starter')
    .controller('QuestionAnalysisCtrl',MainCtrl);

  /** 题目解析 */
  function MainCtrl($scope, RouteData,$ionicLoading,$timeout,$ionicHistory,$httpFactory,$ionicScrollDelegate) {
    /***** Controller ******/
    {
      // 初始化题数据
      $scope.questions = RouteData.analysisList;
      $scope.index = RouteData.analysisIndex?RouteData.analysisIndex:0;

      $scope.firstPage = false;
      reShow();
      $scope.up = up;
      $scope.next = next;

      $scope.navBack = navBack;// 导航-返回
      $scope.viewbulr_close = viewbulr_close;
      $scope.questionError = questionError;
      $scope.suggestDialog = suggestDialog;

      $scope.viewblur = viewblur;
      $scope.closeOther = closeOther;
      $scope.dialogBack = dialogBack;
      $scope.dialogUp = dialogUp;
    }


    /***** function ******/
    // 重新显示页面
    function reShow() {
      $ionicScrollDelegate.scrollTop();
      if ($scope.questions.length - 1 <= $scope.index) {
        $scope.nextText = '返回';
      }else{
        $scope.nextText = null;
      }
      if($scope.index==0){
        $scope.firstPage = true;
      }else{
        $scope.firstPage = false;
      }

      if ($scope.questions.length == $scope.index) {
        // navigator.app.backHistory();// 返回
        // $state.go($rootScope.previousState, $rootScope.previousParams);
        return ;
      }

      $scope.questionsShow = $scope.questions[$scope.index];
      $scope.isCorrect = $scope.questionsShow.isCorrect;
    }

    // 上一题
    function up() {
      if ($scope.index == 0) {
        return;
      }

      $scope.index = $scope.index - 1;
      reShow();
    }

    // 下一题
    function next() {
      if ($scope.questions.length- 1 <= $scope.index) {
        return;
      }

      $scope.index = $scope.index + 1;
      reShow();
    }

    // 导航-返回
    function navBack() {
      // $state.go($rootScope.previousState, $rootScope.previousParams);
      $ionicHistory.goBack();
    }

    /** 用户反馈**/
    function viewbulr_close(){
      $("._modal").css("display","none");
      $("ion-content").removeClass("ws_view_blur");
      $(".button-bar").removeClass("ws_view_blur");
    }

    function suggestDialog(){
      $("._modal").css("display","none");
      if(window.screen.height<800){
        $(".analysis_error_otherError").css("height","200px");
      }else {
        $(".analysis_error_otherError").css("height","350px")
      }
      $(".analysis_error_otherError").css("top","17%");
      $(".suggest_other_corver").css("display","");
      $timeout(function(){
        $("#suggestOther").focus();
      },1);
    }

    //答案错误
    function questionError(id,type){
      var message = $('#suggestOther').val();
      if (type == 4 ? !message||RegExp("^[ ]+$").test(message) : false) {       //为空、全部为空格，false
        $ionicLoading.show({template:"请填写意见"});
        return false;
      }
      $(".suggest_other_corver").css("display","none");
      $("._modal").css("display","none");
      $ionicLoading.show({
        template: ' <div class="analysis_error_background">' +
        '<ion-spinner icon="spiral" class="spinner-light" style="float: left"></ion-spinner>' +
        '<span style="font-size: 20px;">反馈提交中......</span></div>',
        noBackdrop: true
      });

      var content = {};
      content.userId = _appv.currentUser.userId;
      if(type==_app.questionError_answer){
        content.suggest = ("[3]题目"+id+" ：答案有误");
      }
      else if(type==_app.questionError_question){
        content.suggest = ("[3]题目"+id+" ：题干有误");

      }else if(type==_app.questionError_analysis){
        content.suggest = ("[3]题目"+id+" ：解析有误");
      }
      else if(type==_app.questionError_other){
        var suggest = $("#suggestOther").val();
        content.suggest = ("[3]题目"+id+" ："+suggest);
      }
      $timeout(function(){
        $httpFactory.user.feedback(content.userId,JSON.stringify(content))
          .then(function (result) {
            $ionicLoading.show({
              template: '' +
              '<div class="analysis_error_background">' +
              '<i class="ion-ios-checkmark-outline" style="padding-right: 15px;font-size: 24px;"></i>' +
              '<span style="font-size: 20px;">提交成功!</span></div>',
              noBackdrop: true
            });
            $timeout(function () {
              $ionicLoading.hide();
              viewbulr_close();
            },1000);
          })
      },2000);
    }

    function viewblur(){
      $("._modal").css("display","");
      $("ion-content").addClass("ws_view_blur");
      $(".button-bar").addClass("ws_view_blur");
    }

    function closeOther(){
      $(".suggest_other_corver").css("display","none");
      $("._modal").css("display","");
    }

    function dialogBack(){
      $(".analysis_error_otherError").css("top","");
    }

    function dialogUp(){
      $(".analysis_error_otherError").css("top","17%");
    }
  }
})();
