/**
 * Created by Administrator on 2016/1/8.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('FeedbackCtrl', MainController)

  /** 意见反馈 */
  function MainController($scope, $httpFactory, $timeout, $ionicPopup, $ionicLoading, $ionicHistory) {
    console.log('into FeedbackCtrl');

    // 初始化Controller
    {
      $scope.data = {};
      $scope.max = 100;
      $scope.cur = 0;
      $scope.haveFocus = false;
      $scope.save = save;
      $scope.detail = detail;
      initKeyboardListener();
      $timeout(function () {
        $scope.haveFocus = true;
      }, 200);
    }

    function initKeyboardListener() {
      if (_app.isIos) {
        window.addEventListener('native.keyboardshow', keyboardShowHandler);
        window.addEventListener('native.keyboardhide', keyboardHideHandler);
      }
    }

    function keyboardShowHandler() {
      if (!$scope.haveFocus && cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.close()
        $scope.haveFocus = true;
      }
    }

    function keyboardHideHandler() {

    }

    function detail() {
      $scope.data.suggest = $scope.data.suggest.replace(/\s+/g, "");
      var suggest = $scope.data.suggest;
      if (suggest.length > $scope.max) {
        suggest = suggest.substring(0, $scope.max);
        $scope.data.suggest = suggest;
      }
      $scope.cur = suggest.length;
      console.log("您已经输入" + $scope.cur + "字符");
    }

    function save(type) {

      if (type == 1 ? (!$('#contentBug').val() || RegExp("^[ ]+$").test($('#contentBug').val())) : !$('#contentExp').val() || (!$('#contentExp').val() || RegExp("^[ ]+$").test($('#contentExp').val()))) {
        $ionicLoading.show({template: "请填写意见或反馈"});
        return false;
      }

      var content = {};
      content.userId = window._appv.currentUser.userId;
      content.suggest = (type == 1 ? "[1]" + $('#contentBug').val() : "[2]" + $('#contentExp').val());
      content.phone = $('#contentPhone').val();
      //if (content.suggest.length > 1000) {
      //  $ionicPopup.alert({
      //    title: '提示',
      //    template: '内容超长,请精简填写',
      //    okText: "确定"
      //  });
      //  return;
      //}

      $httpFactory.user.feedback(content.userId, JSON.stringify(content))
        .then(function (result) {
          $ionicPopup.alert({
            title: '提示',
            template: result.data.message,
            okText: "确定"
          });
        })
    }

    // 导航-返回
    $scope.navBack = function () {
      //$state.go($stateParams.sourceState, $stateParams.sourceParams);// 哪里来,回那里去
      // $state.go('main.practice');// 哪里来,回那里去
      $ionicHistory.goBack();
    }

  }

})();
