(function () {
    'use strict';

    angular
        .module('starter')
        .controller('InvitationCtrl', InvitationCtrl);

    function InvitationCtrl($scope, $ionicPopup, $ionicLoading, $httpFactory, $ionicHistory) {
        {

            $scope.isTrue = false;
            $scope.currentUser = window._appv.currentUser;

            $scope.share = share;
            $scope.openShare = openShare;

            var activityInfo;
            getInviteCode();

            $scope.third = {}
            window.share.wechat.installed().then(function (isInstalled) {
                if (1===isInstalled || !!isInstalled) {
                    $scope.third.hasWechat = true;
                } else {
                    $scope.third.hasWechat = false;
                }
            })
            window.share.qq.installed().then(function (isInstalled) {
                if (1===isInstalled || !!isInstalled) {
                    $scope.third.hasQQ = true;
                } else {
                    $scope.third.hasQQ = false;
                }
            })

        }

        function shareTo(type){
          var inviteCode = _appv.currentUser.inviteCode?_appv.currentUser.inviteCode:'';
          var title = $scope.shareInfo.params.title.replace('{{inviteCode}}',inviteCode);
          var description = $scope.shareInfo.params.description.replace('{{inviteCode}}',inviteCode);
          var thumb = $scope.shareInfo.params.thumb;
          var url = $scope.shareInfo.params.url;
          switch (type) {
              case _app.shareType_wechat:
                  window.share.wechat.share(title,description,thumb,url).then(success, fail);
                  return true;
              case _app.shareType_timeLine:
                  window.share.wechat.shareTimeLine(title,description,thumb,url).then(success,fail);
                  return true;
              case _app.shareType_qq:
                  window.share.qq.share(title,description,thumb,url).then(success, fail);
                  return true;
              case _app.shareType_qzone:
                  window.share.qq.shareToQzone(title,description,thumb,url).then(success,fail);
                  return true;
          }
        }

        function share(type) {
          //检查是否安装
          if(type==_app.shareType_wechat || type==_app.shareType_timeLine){
            if(!$scope.third.hasWechat){
              $ionicLoading.show({template:'没有检测到微信的安装记录 或 微信版本太低'});
              return;
            }
          }
          if(type==_app.shareType_qq || type==_app.shareType_qzone){
            if(!$scope.third.hasWechat){
              $ionicLoading.show({template:'没有检测到QQ的安装记录 或 QQ版本太低'});
              return;
            }
          }
          //准备分享的数据
          $ionicLoading.show({template:'请稍等'});
          $httpFactory.sys.sysConfig('shareApp').then(function (res) {
            if(res.data.result == 0){
              $scope.shareInfo = JSON.parse(res.data.object[0].value);
              shareTo(type);
            }else{
              $ionicLoading.show({template:'没有获取到分享信息，请稍后再试'});
            }
          })
            // var url = '';
            // var mycode = ''
            // if (!activityInfo) {
            //     $ionicLoading.show({template: '未获取到分享的信息;'});
            //     return;
            // }
            // if ($scope.invitaion.inviteCode && (activityInfo.activityType == "invite" || activityInfo.activityType == window._app.activityType_invite)) {
            //     url = "?code=" + $scope.invitaion.inviteCode;
            //     mycode = "我的邀请码：" + $scope.invitaion.inviteCode;
            // }


            // $ionicLoading.show({template: 'Loading....', duration: 2000});
            //
            // switch (type) {
            //     case _app.shareType_wechat:
            //         window.share.wechat.share(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
            //             activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
            //         return true;
            //     case _app.shareType_timeLine:
            //         window.share.wechat.shareTimeLine(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
            //             activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
            //         return true;
            //     case _app.shareType_qq:
            //         window.share.qq.share(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
            //             activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
            //         return true;
            //     case _app.shareType_qzone:
            //         window.share.qq.shareToQzone(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
            //             activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
            //         return true;
            // }
        }

        function success() {
            // addlottery()
            $ionicLoading.show({template: '分享成功'});
            $scope.sharePopup.close();
        }

        function fail() {
            $ionicLoading.show({template: '分享失败'});
        }

        function openShare() {
            $scope.sharePopup = $ionicPopup.show({
                cssClass: 'myPopup',
                templateUrl: 'app/share/share.html',
                scope: $scope
            });
        };


        //获取邀请码
        function getInviteCode() {
            $httpFactory.user.getInviteCode($scope.currentUser.userId).then(function (res) {
                if (!!res.data.object){
                    $scope.invitaion = res.data.object;
                    getActivityInfo();
                }
            })
        }

        //获取活动详情
        function getActivityInfo() {
            $httpFactory.activity.getInfo($scope.invitaion.inviteActivityId).then(function (res) {
                if (!!res.data.object) {
                    $scope.activityInfo = !!res.data.object[0] ? res.data.object[0] : res.data.object;
                    activityInfo = $scope.activityInfo;
                } else {
                    //$ionicLoading.show({template: "获取不到活动信息"});
                }
            })
        }

        function addlottery() {//添加抽奖次数
            $httpFactory.user.addLottery($scope.currentUser.userId, $scope.currentUser.token).then(function (res) {
                /* if (res.data.curRec)
                 $ionicLoading.show({template:res.data.message});*/

            })
        }

        /* $ionicPopover.fromTemplateUrl("templates/common/share-popover.html", {
         scope: $scope
         })
         .then(function (popover) {
         $scope.popover = popover;
         //$scope.popover.show(".ion-share");
         })

         $scope.openShare = function ($event) {
         if (!!$scope.activityInfo) {
         if (!!$scope.invitaion.inviteCode) {
         $scope.popover.show($event);
         } else {
         $ionicLoading.show({template: "获取不到邀请码"});
         }
         } else {
         $ionicLoading.show({template: "获取不到活动信息"});
         }
         };
         $scope.closePopover = function () {
         $scope.popover.hide();
         };
         //销毁事件回调处理：清理popover对象
         $scope.$on("$destroy", function () {
         $scope.popover.remove();
         });
         // 隐藏事件回调处理
         $scope.$on("popover.hidden", function () {
         // Execute action

         });
         //删除事件回调处理
         $scope.$on("popover.removed", function () {
         // Execute action
         });*/


        // 导航-返回
        $scope.navBack = function () {
            //$state.go($stateParams.sourceState, $stateParams.sourceParams);// 哪里来,回那里去
            // $state.go('main.practice');// 哪里来,回那里去
            $ionicHistory.goBack();
        }

    }

})
();
