/**
 * Created by Administrator on 2016/1/8.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('LotteryRecordCtrl', LotteryRecordCtrl)

    /** 中奖记录 */
    function LotteryRecordCtrl($scope, $httpFactory,CheckInputUtil, $ionicModal,$ionicPopup, $ionicLoading,$ionicHistory) {
        console.log('into LotteryRecordCtrl');
        {
            $scope.prize;// 选择奖品
            $scope.dataAddress = {};// 初始化`填写地址窗口`,数据容器
            $scope.addressOpen = addressOpen;// 打开`填写地址窗口`
            $scope.closeAddress = closeAddress;// 关闭`填写地址窗口`
            $scope.saveAddress = saveAddress;// 提交收货地址
            if(window._appv.currentUser){
                var currentUser = window._appv.currentUser;
                var userId=currentUser.userId
                var token = currentUser.token;
            }

            initData();// 获取记录

        }

        function initData() {
            $httpFactory.lottery.lotteryLog(userId, token).then(function (result) {
                if (result.data.result == 0) {
                    $scope.logs = result.data.object;
                }
                console.log(result);
            });
        }

        function addressOpen(prize) {
            $scope.prize = prize;// 选择奖品
            $ionicModal.fromTemplateUrl('app/templates/invitation/lotteryAdd.html', {
                scope: $scope,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.modal = modal;
                $scope.modal.show();
            });

        }

        function saveAddress() {
            if (!$scope.dataAddress.receiverName) {
                $ionicLoading.show({template:"称呼不能为空"});
                return false;
            }
            if (!RegExp("^[\u4e00-\u9fa5a-zA-Z]+$").test($scope.dataAddress.receiverName)) {
                $ionicLoading.show({template: '称呼只能输入中英文'});
                return false;
            }

            if (!$scope.dataAddress.mobile) {
                $ionicLoading.show({template:"电话号码不能为空"});
                return false;
            }
            if(!RegExp("^[0-9]+$").test($scope.dataAddress.mobile)){
                $ionicLoading.show({template:"电话号码只能为数字"});
                return false;
            }

            if (!$scope.dataAddress.address) {
                $ionicLoading.show({template:"地址不能为空"});
                return false;
            }


            $ionicPopup.confirm({
                title: "再次确认",
                template: "" +
                "<p><span>用户名： </span>" + $scope.dataAddress.receiverName + "</p>" +
                "<p><span>联系方式：</span>" + $scope.dataAddress.mobile + "</p>" +
                "<p><span>收货地址：</span>" + $scope.dataAddress.address + "</p>",
                okText: "确定",
                cancelText: "取消"
            }).then(function (res) {
                if (res) {

                    //$scope.dataAddress = {"receiverName":"昌老师","mobile":"15068748770","address":"浙江省杭州市西湖区古墩路616号同人精华大厦1座1102室"}
                    $httpFactory.lottery.saveAddress(userId, $scope.prize.id, token, $scope.dataAddress).then(function (res) {
                        if (res.data.result != 0) {
                            $ionicLoading.show({template:res.data.message});
                        } else {
                            // 更新奖品数据
                            $ionicLoading.show({template:res.data.message});
                            initData();
                            closeAddress();
                        }

                    })
                }
            });

        }

        function closeAddress() {
            $scope.modal.hide();
        }

        // 导航-返回
        $scope.navBack = function () {
            //$state.go($stateParams.sourceState, $stateParams.sourceParams);// 哪里来,回那里去
            // $state.go('main.practice');// 哪里来,回那里去
            $ionicHistory.goBack();
        }

    }


})();
