(function () {
    'use strict';

    angular
        .module('starter')
        .controller('ActivityCtrl', ActivityCtrl);

    function ActivityCtrl($scope, $ionicPopup, $stateParams, $httpFactory, localStorageService, $ionicLoading, $state, $ionicNavBarDelegate) {
        {
            var activityId = $stateParams.activityId;
            $scope.share = share;
            $scope.openShare = openShare;
            $scope.navBack = navBack;

            $scope.currentUser = window._appv.currentUser;
            $scope.fromMain = $stateParams.fromMain;
            $scope._ios = window._app.isIos ? '_ios' : '';

            var activityInfo;

            if ($scope.currentUser) {
                getInviteCode();      //获取邀请码
            }
            getActivityInfo();      //获取活动详情

            $scope.third={}
            window.share.wechat.installed().then(function (isInstalled) {
                if (1===isInstalled || !!isInstalled) {
                    $scope.third.hasWechat = true;
                } else {
                    $scope.third.hasWechat = false;
                }
            })
            window.share.qq.installed().then(function (isInstalled) {
                if (1===isInstalled || !!isInstalled) {
                    $scope.third.hasQQ = true;
                } else {
                    $scope.third.hasQQ = false;
                }
            })
        }

        function share(type) {
            var url = '';
            var mycode = ''
            if (!activityInfo) {
                $ionicLoading.show({template: '未获取到分享的信息；'});
                return;
            }
            if (!!$scope.invitaion.inviteCode && (activityInfo.activityType == "invite" || activityInfo.activityType == window._app.activityType_invite)) {
                url = "?code=" + $scope.invitaion.inviteCode;
                mycode = "我的邀请码：" + $scope.invitaion.inviteCode;
            }
            $ionicLoading.show({template: 'Loading....', duration: 2000});

            switch (type) {
                case _app.shareType_wechat:
                    window.share.wechat.share(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
                        activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
                    return true;
                case _app.shareType_timeLine:
                    window.share.wechat.shareTimeLine(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
                        activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
                    return true;
                case _app.shareType_qq:
                    window.share.qq.share(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
                        activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
                    return true;
                case _app.shareType_qzone:
                    window.share.qq.shareToQzone(activityInfo.argsTitle + mycode, activityInfo.argsDescription,
                        activityInfo.argsImageUrl, activityInfo.argsUrl + (window._app.isIos ? '_ios' : '') + url).then(success, fail);
                    return true;
            }
        }

        function success() {
            addlottery();
            $ionicLoading.show({template: '分享成功'});
            $scope.sharePopup.close();
        }

        function fail() {
            $ionicLoading.show({template: '分享失败'});
        }

        function openShare() {
            $scope.sharePopup = $ionicPopup.show({
                cssClass: 'myPopup',
                templateUrl: 'app/share/share.html',
                scope: $scope
            });
        };


        function navBack() {
            if (!$scope.fromMain) {
                $ionicNavBarDelegate.back();
            } else {
                if (!$scope.currentUser) {
                    $state.go('login');
                }
                else {
                    if (!!localStorageService.get("myBook")) {
                        $state.go('menu.main.exp')
                    }
                }
            }
        }

        //获取邀请码
        function getInviteCode() {
            $httpFactory.user.getInviteCode($scope.currentUser.userId).then(function (res) {
                if (!!res.data.object)
                    $scope.invitaion = res.data.object;
            })
        }

        //获取活动详情
        function getActivityInfo() {
            $httpFactory.activity.getInfo(activityId).then(function (res) {
                if (!!res.data.object) {
                    $scope.activityInfo = !!res.data.object[0] ? res.data.object[0] : res.data.object;
                    activityInfo=$scope.activityInfo;
                } else {
                    $ionicLoading.show({template: "获取不到活动信息"});
                }
            })
        }

        //添加抽奖次数
        function addlottery() {
            $httpFactory.user.addLottery($scope.currentUser.userId, $scope.currentUser.token).then(function (res) {
                /* if (res.data.curRec)
                 $ionicLoading.show({template:res.data.message});*/

            })
        }


    }
})
();
