(function () {
    'use strict';

    angular
        .module('starter')
        .controller('MyVideoCtrl', MainCtrl);

    function MainCtrl($scope, $httpFactory, $state, RouteData,$ionicHistory) {
        {
            $scope.noMOreData=true;
            $scope.videoList=[];

            $scope.changeType = changeType;
            $scope.toVideoInfo = toVideoInfo;
            $scope.loadMore = loadMore;
            $scope.toVideoType = toVideoType;
            $scope.navBack = navBack;

            var currentUser = window._appv.currentUser;
            var pageSize = 10, currentPage = 0;
            var oldData;
        }

        function initData(categoryId, pageSize, currentPage) {
            $httpFactory.video.myList(currentUser.userId, categoryId, pageSize, currentPage).then(function (res) {
                if (res.data.result === 0) {
                    $scope.videoType = res.data.object.Category;
                    oldData= res.data.object.Product;
                    if(pageSize > res.data.object.Product.length){
                        $scope.noMOreData=false;
                    }
                    $scope.videoList=$scope.videoList.concat(oldData);
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            })
        }

        function changeType(index) {
            var categoryId;
            (index || index==0)  && (categoryId = $scope.videoType[index].id);
            $scope.categoryId = categoryId;

            currentPage = 1;
            $scope.noMOreData=true;
            $scope.videoList=[];
            initData($scope.categoryId, pageSize, currentPage)
        }

        function loadMore() {
            currentPage++;
            initData($scope.categoryId, pageSize, currentPage);

        }

        function toVideoInfo(video) {
            RouteData.videoInfo = video;
            $state.go('menu.videoInfo');
        }

        function toVideoType(){
            $state.go('menu.videoType');
        }

        function navBack(){
            $ionicHistory.goBack();
        }

    }
})();
