(function () {
    'use strict';

    angular
        .module('starter')
        .controller('MycourseCtrl', MycourseCtrl);

    function MycourseCtrl($scope,$ionicHistory,$httpFactory,RouteData,$state,$ionicLoading,$cordovaAppVersion) {

        {
            $scope.data={};
            $scope.toVideoInfo = toVideoInfo;
            $scope.gotoMyVideo = gotoMyVideo;
            $scope.navBack = navBack;

          var currentUser= window._appv.currentUser;
            var videoOpenInfo;
            var appVersion;
            initData();
        }

        // 初始化系统配置
        $httpFactory.sys.sysConfig('wosaiLive').then(function (response) {
            if (response.data.result == 0) {
                $scope.data.wosaiLive = JSON.parse(response.data.object[0].value);
            }
        });

        function initData(){
            $httpFactory.video.myList(currentUser.userId,"",5,1).then(function(res){
                if(res.data.result == 0){
                    $scope.videoList = res.data.object.Product;
                }
            })
            /*$httpFactory.live.myList(currentUser.userId,"",currentUser.token).then(function(res){
                console.log(res);
                if(0 === res.data.result){
                    $scope.liveList = res.data.object;
                }
            })*/
          if (window._app.isWeb) return;
          $cordovaAppVersion.getVersionNumber().then(function (version) {
            appVersion = version;
            $httpFactory.sys.sysConfig('wosaiVideo').then(function (response) {
              videoOpenInfo=JSON.parse(response.data.object[0].value);
              if(appVersion===videoOpenInfo.appVersion){
                if(videoOpenInfo.isOpen){
                  $scope.videoOpen = true;      //判断版本开关
                }
              }
            });
          });

        }

        function toVideoInfo(video){
            RouteData.videoInfo = video;
            $state.go('menu.videoInfo');
        }

        function gotoMyVideo(){
          if(appVersion===videoOpenInfo.appVersion){
            if(videoOpenInfo.isOpen){
              $state.go("menu.myVideo");
            }else{
              $ionicLoading.show({template: "我的课程即将上线，敬请期待"});
            }
          }else{
            $state.go("menu.myVideo");
          }
        }

        // 导航-返回
        function navBack() {
            //$state.go($stateParams.sourceState, $stateParams.sourceParams);// 哪里来,回那里去
            // $state.go('main.practice');// 哪里来,回那里去
            $ionicHistory.goBack();
        }

    }

})
();
