(function () {
  'use strict';

  angular
    .module('starter')
    .controller('SelfCenterCtrl', SelfCenterCtrl);

  function SelfCenterCtrl($scope, $rootScope, $ionicActionSheet, $state, localStorageService, $ionicLoading, $httpFactory, $location) {

    if (!window._appv.currentUser) {
      $state.go("login");
      return
    }

    $scope.goActivityInfo = goActivityInfo;

    $scope.currentUser = window._appv.currentUser;
    var updateimg = true;

    $httpFactory.user.myMessage.noReadSum().then(function (response) {
      $scope.noReadSum = response.data.object;
    });

    $scope.returnPage = window._app.pageUserCenter;

    $scope.joinQQGroup = localStorageService.get("joinQQGroup");// 一键加群
    $scope.openQQ = openQQ;

    // 获取用户所在学校
    if (!!localStorageService.get('school')) {
      $scope.citySelected = localStorageService.get('school').city;
      $scope.districtSelected = localStorageService.get('school').district;
      $scope.schoolSelected = localStorageService.get('school');
    } else {
      getPosition();
    }

    /****************************************************************************/

    function getPosition() {
      !!$scope.currentUser.schoolId && $httpFactory.selfCenter.area.getAll($scope.currentUser.schoolId).then(function (res) {
        if (res.data.result == 0) {
          $scope.citySelected = res.data.object.city;
          $scope.districtSelected = res.data.object.district;
          $scope.schoolSelected = res.data.object;
          localStorageService.set('school', res.data.object);
        } else {
          //
        }
      }, function (error) {
        $ionicLoading.show({template: error.data});
      });
    }

    function openQQ(joinQQGroup) {
      $ionicLoading.show({template: "正在打开...", duration: 3000});
      if (_app.isWeb) {
        // 方式一(唤醒PCQQ－适合电脑端)： http://jq.qq.com/?_wv=1027&k=2GxZBsK
        // 方式二(唤醒手机QQ－适合手机端)：http://shang.qq.com/wpa/qunwpa?idkey=4287dd81bb97e103a39c6dfc271af0c60b668a3fab2f05949fb4e6bd7566f8e4
        window.location.href = "http://shang.qq.com/wpa/qunwpa?idkey=" + joinQQGroup.ios.key;
      } else {
        // window.open("http://jq.qq.com/?_wv=1027&k=y-stNxKaFTfKNeDKRXdk9FXOKEpG22PG", "_system");// 依赖插件 cordova-plugin-in_appbrowser
        if (_app.isAndroid) {
          // JoinQQGroup.open({key:'y-stNxKaFTfKNeDKRXdk9FXOKEpG22PG'});
          JoinQQGroup.open({key: joinQQGroup.android.key});
        } else {
          //JoinQQGroup.open({uid:'498644453',key:'0160929211e558ce77c3c044c510920d80c91088c1d047e66b27f57b40e8ba66'});
          JoinQQGroup.open({uin: joinQQGroup.ios.uin, key: joinQQGroup.ios.key});
        }
      }
    }

    /*------------活动列表-------------*/
    $httpFactory.activity.getList(2, 1, window._app.activityType_userCenter).then(function (res) {
      if (res.data.result == 0) {
        $scope.activity_one = res.data.object[0];
        $scope.activity_two = res.data.object[1];
      }
    });

    function goActivityInfo(activity) {
      if (activity.webUrl) {
        //iabRef = window.open(activity.webUrl, '_blank', 'location=no');
        $state.go('browser', {activity: activity});
      } else if (activity.activityType == 1) {
        $state.go('lottery');
      } else if (activity.activityType == 2) {
        $state.go('invitation');
      } else {
        $location.path('/activity/' + activity.id);
      }
    }

    /*------------头像-------------*/
    function onPhotoDone(imageURI) {
      updateimg = false;
      //显示图片
      var done = function (res) {
        updateimg = true;
        if (JSON.parse(res.response).result == 0) {
          $scope.currentUser.icon1 = JSON.parse(res.response).object.icon1;
          window._appv.currentUser = $scope.currentUser;
          $ionicLoading.show({template: "更换头像成功"});
          $scope.cacheSrcUpdate = JSON.parse(res.response).object.icon1;// 更新新头像显示 & 通知缓存更新(使其下次打开,可立即从缓存中获取)

        } else {
          $ionicLoading.show({template: "更换头像失败"});

        }

      };
      var fail = function (e) {
        $ionicLoading.show({template: "更换头像失败"});
        updateimg = true;
      };

      var options = new FileUploadOptions();
      //options.params = {aaa: "aaaaa"};
      options.fileKey = "file";
      options.fileName = "myphoto.jpg";
      options.mimeType = "image/jpeg";
      var ft = new FileTransfer();
      var server = window._config.domain_name + 'user/upload/image/' + $scope.currentUser.userId;
      ft.upload(imageURI, encodeURI(server), done, fail, options);

      // 更新显示&缓存
    }

    function onPhotoFail(message) {
      //warningForm(null, "获取相册或拍照失败");
      updateimg = true;
    }

    function makePhoto() {//拍照
      navigator.camera.getPicture(onPhotoDone, onPhotoFail, {
        quality: 100,
        targetWidth: 150,
        targetHeight: 150,
        destinationType: navigator.camera.DestinationType.FILE_URI,
        allowEdit: true,
      });
    }

    function takePhoto() {
      navigator.camera.getPicture(onPhotoDone, onPhotoFail, {
        quality: 100,
        targetWidth: 150,
        targetHeight: 150,
        destinationType: navigator.camera.DestinationType.FILE_URI,
        sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM,
        allowEdit: true,
      });
    }

    $scope.showAvatar = function () {
      if (updateimg) {
        $ionicActionSheet.show({
          titleText: '选择照片',
          cancelText: '取消',
          buttons: [{text: '从相册中选取'}],
          cancel: function () {
            console.log("取消了");
            updateimg = true;
          },
          // destructiveText: '拍照',
          // destructiveButtonClicked: function () {
          //     makePhoto();
          //     return true;
          // },
          buttonClicked: function (index) {
            switch (index) {
              case  0:
              default:
                takePhoto();
                break;
            }
            return true;
          }
        });
      }
    };

  }

})
();
