/**
 * Created by Administrator on 2016/1/8.
 */
(function () {
    'use strict';

    angular.module('starter')
        .controller('BindPhoneCtrl', MainController)

    /** 绑定手机 */
    function MainController($scope, $ionicPopup, $ionicLoading, $httpFactory, CheckInputUtil, RouteData,$interval,$state,$ionicHistory) {
        console.log('into BindPhoneCtrl');

        // 初始化Controller
        {
            var currentUser = window._appv.currentUser;
            $scope.data = {};
            $scope.second = 60;
            $scope.text = '发送';
            $scope.getCode = getCode;
            $scope.bindPhone = bindPhone;
            $scope.closePopup=closePopup;
            $scope.regBindPhone=regBindPhone;
            $scope.navBack = navBack;
        }


        // 获取验证码
        function getCode() {
            var mobile = $scope.data.mobile;
            var mobileClass = bindPhoneForm.mobile.classList;
            if (mobileClass.contains(ERROR.notRequired)
                || mobileClass.contains('ng-invalid-pattern')) {
                $ionicLoading.show({template: ERROR.mobile});
                return false;
            }
            if (!CheckInputUtil.mobile(mobile)) {
                $ionicLoading.show({template: "手机号码格式错误"});
                return;
            }

            $httpFactory.login.getCode(mobile, window._app.mobile_code_mobile_binding)
                .then(
                    function (res) {
                        if (res.data.result == 0) {
                            $ionicLoading.show({template: '发送成功'});
                            //倒计时
                            var timeStop = $interval(function () {
                                if ($scope.second <= 0) {
                                    $interval.cancel(timeStop);
                                    $scope.text = '发送';
                                    $scope.second = 60;
                                    $scope.color = {};
                                } else {
                                    $scope.text = '已发送(' + $scope.second + ')';
                                    $scope.color = {'color': '#959595'};
                                    $scope.second--
                                }
                            }, 1000);
                            $scope.data.canCount = true;
                        } else {
                            $ionicLoading.show({template: res.data.message});
                        }
                    },
                    function (error) {
                        $ionicLoading.show({template: ERROR.later});
                    }
                );
        }

        // 绑定手机
        function bindPhone() {

            /** 先校验 */
                //var mobile = $scope.data.mobile;
                //var randomCode = $scope.data.randomCode;
            var mobile = bindPhoneForm.mobile.value;
            var randomCode = bindPhoneForm.randomCode.value;

            var mobileClass = bindPhoneForm.mobile.classList;
            if (mobileClass.contains(ERROR.notRequired)
                || mobileClass.contains('ng-invalid-pattern')) {
                $ionicLoading.show({template: ERROR.mobile});
                return false;
            }
            if (!CheckInputUtil.mobile(mobile)) {
                $ionicLoading.show({template: "手机号码格式错误"});
                return;
            }

            if (!!currentUser.mobile && currentUser.mobile == mobile) {
                $ionicLoading.show({template: '您已经绑定此号码！'});
                return false;
            }

            if (randomCode == null ||　""===randomCode) {
                $ionicLoading.show({template: '请输入验证码'});
                return false;
            }

            var mobileClass = bindPhoneForm.mobile.classList;
            if (mobileClass.contains(ERROR.notRequired)
                || mobileClass.contains('ng-invalid-pattern')) {
                $ionicLoading.show({template: ERROR.mobile});
                return false;
            }

            /*********************************************************/
            var content = {};
            content.mobile = $scope.data.mobile;
            content.randomCode = $scope.data.randomCode;

            var userId = -1;
            if (currentUser != null) {
                userId = currentUser.userId;
            }

            var token = currentUser.token;
            $httpFactory.user.bindPhone(userId, token, mobile, randomCode)
                .then(function (result) {
                    console.log(result);
                    $ionicPopup.alert({
                        title: '提示',
                        template: result.data.message,
                        okText: "确定"
                    }).then(function (res) {
                        // 成功-返回
                        if (result.data.result == 0) {
                            currentUser.mobile = mobile;
                            window._appv.currentUser = currentUser;
                            //window.history.back();
                            //$state.go('selfCenter');
                            // $state.go($stateParams.sourceState, $stateParams.sourceParams);// 哪里来,回那里去
                            RouteData.InfoPhone=content;
                            $state.go("menu.bindPass");
                            // $ionicHistory.goBack();// ionic 返回
                        }
                    });
                })
        }

        function closePopup(){
            $scope.errorPopup.close();
        }

        function regBindPhone(){

        }

        function navBack(){
            $ionicHistory.goBack();
        }

    }

})();
