/**
 * Created by Administrator on 2016/1/8.
 */
(function () {
    'use strict';

    angular.module('starter')
        .controller('ChangeNicknameCtrl', ChangeNicknameCtrl);

    /** 修改昵称 */
    function ChangeNicknameCtrl($scope, $state, $ionicLoading, localStorageService, $httpFactory, $ionicHistory) {
        $scope.currentUser = window._appv.currentUser;
        $scope.data = {};
        $scope.data.nickName = !$scope.currentUser.nickName ? "" : $scope.currentUser.nickName;

        $scope.navBack = navBack;
        $scope.updateNickName = updateNickName;

        function updateNickName() {

            var nickName = changeNickForm.nickName.value;


            if (!nickName || RegExp("^[ ]+$").test(nickName)) {       //为空、全部为空格，false
                $ionicLoading.show({template: '请输入昵称'});
                return false;
            }
            if (nickName.length > 10) {               //昵称最大长度16
                $ionicLoading.show({template: '昵称过长，请确保昵称在10位之内'});
                return false;
            }
            //if (!RegUtil.nickName(nickName)) {
            //  return false;
            //}

            $httpFactory.user.changeNickName($scope.currentUser.userId, $scope.currentUser.loginName, nickName).then(function (res) {
                if (res.data.result == 0) {
                    $scope.currentUser = res.data.object;
                    window._appv.currentUser.nickName = $scope.currentUser.nickName;
                    $ionicLoading.show({template: '修改成功！'});
                    window.history.back();
                    //$state.go('selfCenter');
                } else {
                    $ionicLoading.show({template: res.data.message});
                    if (res.data.result == 2) {
                        localStorageService.clearAll();
                        $state.go('login');
                    }
                }
            });
        }


        function navBack() {
            $ionicHistory.goBack();
        }
    }


})();
