/**
 * Created by Administrator on 2016/1/8.
 */
(function () {
    'use strict';

    angular.module('starter')
        .controller('ChangePassCtrl', ChangePassCtrl)

    function ChangePassCtrl($scope, $ionicLoading, $state, $httpFactory, localStorageService,$ionicHistory) {

        $scope.currentUser = window._appv.currentUser;
        $scope.data = {};
        $scope.changePass = changePass;
        $scope.navBack = navBack;

        function changePass() {
            if (!$scope.data.oldPassword || RegExp("^[ ]+$").test($scope.data.oldPassword)) {
                $ionicLoading.show({template: '原密码不能为空'});
                return false;
            }
            if (!$scope.data.newPassword || RegExp("^[ ]+$").test($scope.data.newPassword)) {
                $ionicLoading.show({template: '新密码不能为空'});
                return false;
            } else {
                if (!RegExp("^[0-9a-zA-Z]{6,12}$").test($scope.data.newPassword)) {
                    $ionicLoading.show({template: '请输入6~12位的数字或字母'});
                    return false;
                }
            }
            if ($scope.data.oldPassword === $scope.data.newPassword) {
                $ionicLoading.show({template: '新密码不能与旧密码相同'});
                return false;
            }
            if (!$scope.data.newPasswordConfirm) {
                $ionicLoading.show({template: '再次确认密码不能为空'});
                return false;
            }
            if ($scope.data.newPasswordConfirm !== $scope.data.newPassword) {
                $ionicLoading.show({template: '新密码与确认密码要相同'});
                return false;
            }

            $httpFactory.user.changePass($scope.currentUser.userId, $scope.currentUser.loginName,
                $scope.data.oldPassword, $scope.data.newPassword, $scope.currentUser.token).then(function (res) {
                if (res.data.result == 0) {
                    // window._appv.currentUser = res.data.object;
                    $ionicLoading.show({template: '修改密码成功'});
                    // $state.go('setting');
                    localStorageService.clearAll();
                    $state.go('login');

                } else {
                    $ionicLoading.show({template: res.data.message});
                    if (res.data.result == 2) {
                        localStorageService.clearAll();
                        $state.go('login');
                    }
                }
            }, function (error) {
                $ionicLoading.show({template: ERROR.later});
            });
        }
        function navBack(){
            $ionicHistory.goBack();
        }
    }
})();
