/**
 * Created by Administrator on 2016/1/8.
 */
(function () {
    'use strict';

    angular.module('starter')
        .controller('SchoolInfoCtrl', SchoolInfoCtrl);
    /** @ngInject */
    function SchoolInfoCtrl($scope, $rootScope, $ionicModal, localStorageService, $ionicLoading, $cordovaBarcodeScanner, $state, $httpFactory, $ionicHistory) {

        var token = window._appv.token;
        $scope.currentUser = window._appv.currentUser;
        $scope.groupList = [];
        var choose;

        $scope.navBack = navBack;

        if ($scope.currentUser.schoolId != null) {
            if (!!localStorageService.get('school')) {
                $scope.citySelected = localStorageService.get('school').city;
                $scope.districtSelected = localStorageService.get('school').district;
                $scope.schoolSelected = localStorageService.get('school');
            } else {
                $httpFactory.selfCenter.area.getAll($scope.currentUser.schoolId).then(function (res) {
                    if (res.data.result == 0) {
                        $scope.citySelected = res.data.object.city;
                        $scope.districtSelected = res.data.object.district;
                        $scope.schoolSelected = res.data.object;
                        localStorageService.set('school', res.data.object);
                    } else {
                        //
                    }
                }, function (error) {
                    $ionicLoading.show({template: error.data});
                });
            }
        }

        $httpFactory.school.getGroup($scope.currentUser.userId).then(function (res) {
            if (res.data.result == 0) {
                $scope.groupList = res.data.object;
            }
        }, function (error) {
            $ionicLoading.show({template: error.data});
        });

        /***************************************************************************/
        function clearTemp() {
            $scope.tempCitySelected = null;
            $scope.tempDistrictSelected = null;
            $scope.tempSchoolSelected = null;
        }

        function bindTemp() {
            $scope.citySelected = $scope.tempCitySelected;
            $scope.districtSelected = $scope.tempDistrictSelected;
            $scope.schoolSelected = $scope.tempSchoolSelected;
        }

        /*PositionService.getPosition().then(function(res){
         alert('位置:'+res);
         });*/

        $ionicModal.fromTemplateUrl('app/templates/common/selectUtil.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.modal = modal;
        });

        $scope.openModal = function (type) {
            if (type == "city") {
                clearTemp();
                choose = 1;
                $scope.areaTitle = '市';
                $scope.list = areaJson.object[10].city;
                $scope.cityList = $scope.list;
            }

            $scope.modal.show();

        };

        $scope.closeModal = function () {
            $scope.modal.hide();
        };

        $scope.clear = function () {
            $scope.tempCitySelected = null;
            $scope.tempDistrictSelected = null;
            $scope.list = $scope.cityList;
            choose = 1;
        }

        $scope.select = function (item) {

            if (choose == 1) {
                choose = 2;

                // 对面板强行重绘（解决文字重叠问题）
                $("ion-content").css('display', 'none');
                document.body.offsetWidth;// 在样式变化间加入计算,可强制提交之前的样式变化。否则浏览器会进行事务优化，事务前后无变化的不再重绘
                $("ion-content").css('display', '');

                $scope.tempCitySelected = item;
                $scope.areaTitle = '区';
                $scope.list = item.district;
                $scope.districtList = $scope.list;
            } else if (choose == 2) {
                choose = 3;

                $scope.list = [];
                $scope.tempDistrictSelected = item;
                $scope.areaTitle = '学校';
                $httpFactory.school.shcoolByDisName(item.name).then(function (res) {
                    $scope.list = res.data.object;
                    $scope.schoolList = $scope.list;
                });
            } else if (choose == 3) {
                //更新用户学校
                $scope.tempSchoolSelected = item;
                $httpFactory.school.setSchool($scope.currentUser.userId, $scope.currentUser.loginName, item.id, token)
                    .then(function (res) {
                        if (res.data.result == 0) {
                            bindTemp();
                            $scope.currentUser = res.data.object;
                            window._appv.currentUser.schoolId = res.data.object.schoolId;
                            $ionicLoading.show({template: '绑定学校成功'});
                            localStorageService.remove('school');
                        } else {
                            $ionicLoading.show({template: res.data.message});
                        }
                    }, function (error) {
                        $ionicLoading.show({template: error.data});
                    });

                this.closeModal();
            }
        }

        $scope.ScanCode = function () {
            $cordovaBarcodeScanner.scan().then(function (barcodeData) {
                if (barcodeData.cancelled) {
                    return false;
                }

                var groupId = barcodeData.text.split('=')[1];
                if (groupId == undefined || groupId == null) {
                    $ionicLoading.show({template: '没有找到分组，请确认二维码'});
                    return false;
                }
                //绑定
                $httpFactory.school.bindGroup(groupId, $scope.currentUser.userId, token).then(function (res) {
                    if (res.data.result == 0) {
                        $scope.groupList.push(res.data.object);
                        $ionicLoading.show({template: '绑定分组成功'});
                    } else {
                        $ionicLoading.show({template: res.data.message});
                        if (res.data.result == 2) {
                            localStorageService.clearAll();
                            $state.go('login');
                        }
                    }
                }, function (error) {
                    $ionicLoading.show({template: '请稍后再试喔'});
                });
            }, function (error) {
                $ionicLoading.show({template: '绑定失败：' + error});
            });
        }

        function navBack() {
            $ionicHistory.goBack();
        }
    }

})();
