/**
 * Created by Administrator on 2016/1/8.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('UserSetingCtrl', MainController);

  /** 个人设置 */
  function MainController($scope, localStorageService, $ionicLoading, $httpFactory, $ionicHistory, $ionicActionSheet) {

    {
      $scope.currentUser = window._appv.currentUser;
      $scope.schoolSelected = localStorageService.get('school');
      var updateimg = true;

      initPosition();// 获取用户所在学校
    }

    /****************************************************************************/

    function initPosition() {
      if (!!localStorageService.get('school')) {
        $scope.citySelected = localStorageService.get('school').city;
        $scope.districtSelected = localStorageService.get('school').district;
        $scope.schoolSelected = localStorageService.get('school');
      } else {
        getPosition();
      }
    }

    function getPosition() {
      !!$scope.currentUser.schoolId && $httpFactory.selfCenter.area.getAll($scope.currentUser.schoolId).then(function (res) {
        if (res.data.result == 0) {
          $scope.citySelected = res.data.object.city;
          $scope.districtSelected = res.data.object.district;
          $scope.schoolSelected = res.data.object;
          localStorageService.set('school', res.data.object);
        } else {
          //
        }
      }, function (error) {
        $ionicLoading.show(error.data);
      });
    }

    /*------------头像-------------*/
    function onPhotoDone(imageURI) {
      updateimg = false;
      //显示图片
      var done = function (res) {
        updateimg = true;
        if (JSON.parse(res.response).result == 0) {
          $scope.currentUser.icon1 = JSON.parse(res.response).object.icon1;
          window._appv.currentUser = $scope.currentUser;
          $ionicLoading.show({template: "更换头像成功"});
          $scope.cacheSrcUpdate = JSON.parse(res.response).object.icon1;// 更新新头像显示 & 通知缓存更新(使其下次打开,可立即从缓存中获取)

        } else {
          $ionicLoading.show({template: "更换头像失败"});

        }

      };
      var fail = function (e) {
        $ionicLoading.show({template: "更换头像失败"});
        updateimg = true;
      };

      var options = new FileUploadOptions();
      //options.params = {aaa: "aaaaa"};
      options.fileKey = "file";
      options.fileName = "myphoto.jpg";
      options.mimeType = "image/jpeg";
      var ft = new FileTransfer();
      var server = window._config.domain_name + 'user/upload/image/' + $scope.currentUser.userId;
      ft.upload(imageURI, encodeURI(server), done, fail, options);

      // 更新显示&缓存
    }

    function onPhotoFail(message) {
      //warningForm(null, "获取相册或拍照失败");
      updateimg = true;
    }

    function makePhoto() {//拍照
      navigator.camera.getPicture(onPhotoDone, onPhotoFail, {
        quality: 100,
        targetWidth: 150,
        targetHeight: 150,
        destinationType: navigator.camera.DestinationType.FILE_URI,
        allowEdit: true,
      });
    }

    function takePhoto() {
      navigator.camera.getPicture(onPhotoDone, onPhotoFail, {
        quality: 100,
        targetWidth: 150,
        targetHeight: 150,
        destinationType: navigator.camera.DestinationType.FILE_URI,
        sourceType: navigator.camera.PictureSourceType.SAVEDPHOTOALBUM,
        allowEdit: true,
      });
    }

    $scope.showAvatar = function () {
      if (updateimg) {
        $ionicActionSheet.show({
          titleText: '选择照片',
          cancelText: '取消',
          buttons: [{text: '从相册中选取'}],
          cancel: function () {
            console.log("取消了");
            updateimg = true;
          },
          /*destructiveText: '拍照',
           destructiveButtonClicked: function () {
           makePhoto();
           return true;
           },*/
          buttonClicked: function (index) {
            switch (index) {
              case  0:
              default:
                takePhoto();
                break;
            }
            return true;
          }
        });
      }
    };


    // 导航-返回
    $scope.navBack = function () {
      //$state.go($stateParams.sourceState, $stateParams.sourceParams);// 哪里来,回那里去
      // $state.go('main.practice');// 哪里来,回那里去
      $ionicHistory.goBack();
    }


  }
})();
