(function(){
  'use strict';

  angular
    .module('starter')
    .controller('VideoInfoCtrl',MainCtrl);

  function MainCtrl($scope,RouteData,$ionicHistory,$ionicLoading,$state,$ionicPopup,$httpFactory,$rootScope){
    {
      $scope.navBack = navBack;
      // $scope.videoInfo = RouteData.videoInfo;
      $scope.toBuy = toBuy;
      $scope.pay = pay;
      $scope.toShare = toShare;
      $scope.hasLogin = _appv.currentUser && _appv.currentUser.userId!=-1;
      $scope.share = share;
      $rootScope.refresherVideoInfo = refresherVideoInfo;
      initVideoListion();
      initVideoInfo();
      var vid = document.querySelector('video');
      vid.addEventListener('play', timeupdateListener);
    }

    function timeupdateListener(){
      console.log('播放事件');
        $httpFactory.video.videoPlay(_appv.currentUser.userId,$scope.videoInfo.resList[0].id).then(function(){
          $scope.videoInfo.resList[0].playSum++
        });
        vid.removeEventListener("play", timeupdateListener);// 删除当前事件监听
    }

    function initVideoInfo(){
      $httpFactory.video.updateVideo(_appv.currentUser.userId,RouteData.videoInfo.code,_appv.token).then(function(res){
        if(res.data.result == 0){
          $scope.videoInfo = res.data.object[0]
        }
      })
    }

    function refresherVideoInfo(){

    }

    function initVideoListion(){
      var screen_change_events = "webkitfullscreenchange mozfullscreenchange fullscreenchange MSFullscreenChange";
      $(document).on(screen_change_events, function () {
        console.log('change', document['webkitIsFullScreen'], screen_change_events);
        if (document['webkitIsFullScreen']) {
          window.screen.orientation.lock("landscape");// 横屏
        } else {
          window.screen.orientation.lock("portrait");// 恢复竖屏
        }
      });
    }

    function navBack(){
      $ionicHistory.goBack();
    }

    function toBuy(){
      $ionicLoading.show({template:'您还未购买此视频，请先购买'});
    }

    function pay(){
      RouteData.productPay = {
        productType:_app.orderType_video,
        content:[{
          productCode:$scope.videoInfo.resList[0].proCode,
          productName:$scope.videoInfo.name
        }],
        price:$scope.videoInfo.price
      };
      $state.go('menu.pay');
    }

    function toShare(){
      if($rootScope.hasQQ!=1 && $rootScope.hasWechat!=1){
        $ionicLoading.show({template:'未检测到QQ、微信等分享应用'});
        return;
      }
      $httpFactory.sys.sysConfig('shareApp').then(function(res){
        if(res.data.result == 0){
          var shareJson = res.data.object[0].value;
          $scope.shareData = JSON.parse(shareJson);
        }else{
          $ionicLoading.show({template:'未获取到分享的信息；'});
        }
      });
      $scope.sharePopup = $ionicPopup.show({
        cssClass:'myPopup',
        templateUrl:'app/share/share.html',
        scope:$scope
      });
    }

    function share(type,params){
      if(!params){
        $ionicLoading.show({template:'未获取到分享的信息；'});
        return;
      }
      $ionicLoading.show({template:'Loading....',duration:2000});
      switch (type){
        case _app.shareType_wechat:
          window.share.wechat.share(params.title, params.description, params.thumb, params.url).then(success, fail);return true;
        case _app.shareType_timeLine:
          window.share.wechat.shareTimeLine(params.title, params.description, params.thumb, params.url).then(success, fail);return true;
        case _app.shareType_qq:
          window.share.qq.share(params.title, params.description, params.thumb, params.url).then(success, fail);return true;
        case _app.shareType_qzone:
          window.share.qq.shareToQzone(params.title, params.description, params.thumb, params.url).then(success, fail);return true;
      }
    }
    function success(){
      $ionicLoading.show({template:'分享成功'});
      $scope.sharePopup.close();
    }
    function fail(){
      $ionicLoading.show({template:'分享失败'});
    }

  }
})();
