(function () {
    'use strict';

    angular
        .module('starter')
        .controller('VideoCtrl', MainCtrl);

    function MainCtrl($scope, $httpFactory, $state, RouteData, $rootScope) {
        {
            initData();
            $scope.changeType = changeType;
            $scope.toVideoInfo = toVideoInfo;
            $scope.toVideoType = toVideoType;
            $rootScope.refresherVideo = refresherVideo;
        }

        function refresherVideo() {
            initData();
            $scope.$broadcast('scroll.refreshComplete');
        }

        function initData() {
            $scope.videoLoading  = true;
            $httpFactory.video.list(_appv.currentUser.userId).then(function (res) {
              $scope.videoLoading = false;
                if (res.data.result == 0) {
                    $scope.videoType = res.data.object.Category;
                    $scope.videoList = res.data.object.Product;
                    if (!$scope.videoList || $scope.videoList.length <= 0) {
                        $scope.videoBj = {
                            'background-image': 'url(img/video/bj.png)'
                        }
                    }
                }
            })
        }

        function changeType(index) {
            var categoryId;
            (index || index == 0) && (categoryId = $scope.videoType[index].id);
            $scope.categoryId = categoryId;
            $httpFactory.video.list(_appv.currentUser.userId, categoryId).then(function (res) {
                if (res.data.result == 0) {
                    $scope.videoType = res.data.object.Category;
                    $scope.videoList = res.data.object.Product;
                }
            })
        }

        function toVideoInfo(video) {
            RouteData.videoInfo = video;
            $state.go('menu.videoInfo');
        }

        function toVideoType() {
            $state.go('menu.videoType');
        }


    }
})();
