(function () {
  'use strict';

  angular
    .module('starter')
    .controller('VideoTypeCtrl',MainCtrl);

  function MainCtrl($scope,$httpFactory,$ionicHistory,$ionicLoading) {
    {
      initData();
      initIosCss();
      $scope.navBack = navBack;
      $scope.addOption = addOption;
      $scope.delOption = delOption;
      $scope.edit = false;
      $scope.finish = finish;
    }

    function initIosCss(){
      if(_app.isIos){
        $scope.iosCss={
          top:'15px'
        }
      }
    }

    function initData(){
      $httpFactory.video.typeList(_appv.currentUser.userId).then(function(res){
        if(res.data.result == 0){
          $scope.totalList = res.data.object.total;
          $scope.categoryList = res.data.object.userCategory;
        }
      })
    }

    function navBack(index){
      $ionicHistory.goBack();
    }

    function addOption(index){
      // if($scope.edit) {
        var obj = $scope.totalList[index];
        $scope.totalList.splice(index, 1);
        $scope.categoryList.push(obj);
      // }
    }

    function delOption(index){
      // if($scope.edit){
        var obj = $scope.categoryList[index];
        $scope.categoryList.splice(index,1);
        $scope.totalList.push(obj);
      // }
    }

    function finish(){
      // $scope.edit = !$scope.edit;
      // if(!$scope.edit){
        var ids = '';
        for(var i=0;i<$scope.categoryList.length;i++){
          if(i!=0){
            ids=ids+','+$scope.categoryList[i].id;
          }else{
            ids = $scope.categoryList[i].id
          }
        }
        var data = {
          token:_appv.token,
          content:JSON.stringify({
            ids:ids
          })
        };
        $httpFactory.video.updateCategory(_appv.currentUser.userId,data).then(function(res){
          if(res.data.result == 0){
            $ionicLoading.show({template:'编辑完成！'});
            $ionicHistory.goBack();
          }else{
            $ionicLoading.show({template:res.data.message});
          }
        });
      // }
    }
  }
})();
