/**
 * Created by Administrator on 2016/1/8.
 */
(function () {
  'use strict';

  angular.module('starter')
    .controller('WelcomeCtrl', MainController);

  function MainController($scope, $httpFactory, ShareFactory, $interval, localStorageService, $state, $rootScope, $timeout, $cordovaAppVersion, $cordovaFile, $cordovaFileTransfer, $ionicPlatform) {
    {
      initLocalData();      //初始化本地用户记录
      //   $timeout(function(){
      //     initSysOpen();        //初始化系统开关设置
      // },5000);

      $scope.close = false;
      initData();           //初始化欢迎页图片

      endTime();            //倒计时设置
      $scope.go = go;
      $scope.goWelcomeImg = goWelcomeImg;
      $ionicPlatform.ready(function () {
        getWelcomeImg();          //缓存新的欢迎页
      })
      ShareFactory.initShare();// 初始化第三方分享(需插件初始化完成后)
      $timeout(function () {
        checkInstall();         //第三方安装检测
      }, 4000);
      //initStatus();
      //$scope.goActivityMain = goActivityMain;
      //getActivityInfo();
    }

    function checkInstall() {
      $rootScope.hasQQ = $rootScope.hasWechat = $rootScope.hasTIM = 1;
      if (_app.isWeb) {
        return
      }
      window.share.qq.installed().then(function (installed) {
        $rootScope.hasQQ = installed;
      }, function (res) {
        $rootScope.hasQQ = 0;
        window.share.tim.installed().then(function (installed) {
          $rootScope.hasTIM = installed;
        }, function (res) {
          $rootScope.hasTIM = 0;
        });
      });
      window.share.wechat.installed().then(function (installed) {
        $rootScope.hasWechat = installed;
      }, function (res) {
        $rootScope.hasWechat = 0;
      });
    }

    function initLocalData() {
      if (!localStorageService.get("currentUser")) {
        _appv.currentUser = {userId: -1};
      }
      else {
        _appv.currentUser = localStorageService.get("currentUser");
        _appv.token = localStorageService.get('token');
      }
      $httpFactory.login.sign(_appv.currentUser.userId).then(function (res) {
      });
    }

    function initData() {
      $scope.welcomeImg = {img: 'img/welcome/local_' + _config.platform.code + '.jpg'};
      for (var i = 0; i < window.localStorage.length; i++) {
        var imgObject = localStorageService.get("welcomeImg" + i);
        if (imgObject) {
          if (imgObject.start_time && imgObject.end_time) {
            var start_time = new Date(imgObject.start_time);
            var end_time = new Date(imgObject.end_time);
            var now = new Date();
            start_time <= now && end_time >= now && ($scope.welcomeImg = imgObject);
          } else {
            $scope.welcomeImg = imgObject;
          }
        }
      }
    }

    function goWelcomeImg(welcomeImg) {
      if (welcomeImg.type == 1) {
        $scope.close = true;    //关闭计时器跳转
        $state.go("menu.myActivity");
      }
      else if (welcomeImg.type == 2) {
        if (welcomeImg.webUrl) {
          if (!window.open) {
            alert('插件没加载完成')
          }
          var web = window.open(welcomeImg.webUrl, '_blank', 'location=no');// 依赖插件 cordova-plugin-inappbrowser

          //web.addEventListener('loadstart', iabLoadStart);          //html页面加载前进行iabLoadStart函数操作
          //web.addEventListener('loadstop', iabLoadStop);            //html页面加载后进行iabLoadStop 函数操作
          //web.addEventListener('loaderror', iabLoadError);          //html页面加载错误时进行iabLoadError 函数操作
          web.addEventListener('exit', go);                    //html页面关闭后进行iabClose 函数操作
        }
      }
      else if (welcomeImg.type == 3) {
        // 初始化系统配置
        var joinQQGroupJson;// = JSON.parse('{"android":{"key":"y-stNxKaFTfKNeDKRXdk9FXOKEpG22PG"},"ios":{"uid":"498644453","key":"0160929211e558ce77c3c044c510920d80c91088c1d047e66b27f57b40e8ba66"}}');
        $httpFactory.sys.sysConfig('joinQQGroup').then(function (response) {
          if (response.data.result == 0) {
            joinQQGroupJson = JSON.parse(response.data.object[0].value);
            if (_app.isWeb) {
              window.location.href = "http://jq.qq.com/?_wv=1027&k=2GxZBsK";
            } else {
              // window.open("http://jq.qq.com/?_wv=1027&k=2GxZBsK", "_system");// 依赖插件 cordova-plugin-inappbrowser
              if (_app.isAndroid) {
                JoinQQGroup.open({key: joinQQGroupJson.android.key});
              } else {
                JoinQQGroup.open({uin: joinQQGroupJson.ios.uin, key: joinQQGroupJson.ios.key});
              }
            }
          }
        });
      }
    }

    function getWelcomeImg() {
      var key = 'welcome-img_' + _config.platform.code;
      $httpFactory.sys.sysConfig(key).then(function (res) {
        if (res.data.result == 0) {
          var welcomeImg = JSON.parse(res.data.object[0].value);
          for (var i = 0; i < welcomeImg.length; i++) {
            var lastName = welcomeImg[i].img.split('.');          //获取文件名后缀
            var localUrl = "welcomeImg" + i + '.' + lastName[lastName.length - 1];      //赋予新的文件名
            var img = welcomeImg[i];
            // img2Base64(localUrl,img);
            imgFileDownLoad(localUrl, img);          //下载缓存到本地文件
          }
        }
      });
    }

    function imgFileDownLoad(fileName, welcomeImg) {
      welcomeImg.img = adaptation(welcomeImg.img);// 设备屏幕适配
      var rootPath;      //设置缓存目录
      _app.isAndroid && (rootPath = cordova.file.externalDataDirectory);      //安卓目录
      _app.isIos && (rootPath = cordova.file.documentsDirectory);          //ios目录
      $cordovaFile.checkDir(rootPath, 'welcomeImg').then(dirSuccess, dirFault);
      //检测到目录
      function dirSuccess() {
        $cordovaFile.checkFile(rootPath, 'welcomeImg/lock_' + fileName).then(lockFileSuccess, lockFileFault);
      }

      //检测不到目录
      function dirFault() {
        $cordovaFile.createDir(rootPath, 'welcomeImg', true).then(dirSuccess);
      }

      //检测到锁文件
      function lockFileSuccess() {
        $cordovaFile.removeFile(rootPath, 'welcomeImg/lock_' + fileName).then(function () {
          console.log('下载失败，删除锁文件');
          $cordovaFile.removeFile(rootPath, 'welcomeImg/' + fileName).then(function () {
            console.log('下载失败，删除源文件');
            fileFault();
          });
        });
      }

      //检测不到锁文件
      function lockFileFault() {
        $cordovaFile.checkFile(rootPath, 'welcomeImg/' + fileName).then(fileSuccess, fileFault);
      }

      //检测到图片文件
      function fileSuccess() {
        var localStorageName = fileName.split('.')[0];
        if (welcomeImg.updateDate &&         //数据库更新时间
            //localStorageService.get(localStorageName).updateDate &&       //本地更新时间
          welcomeImg.updateDate != localStorageService.get(localStorageName).updateDate) {         //两者不一致则覆盖下载
          fileFault();    //若更新时间不一致，则覆盖下载
        }
      }

      //检测不到图片文件
      function fileFault() {
        //添加锁文件
        $cordovaFile.createFile(rootPath, 'welcomeImg/lock_' + fileName, true).then(function () {
          //开始下载文件
          $cordovaFileTransfer.download(welcomeImg.img, rootPath + 'welcomeImg/' + fileName, {}, true).then(
            //下载成功
            function (res) {
              $cordovaFile.removeFile(rootPath, 'welcomeImg/lock_' + fileName).then(); //下载成功后，删除锁文件
              welcomeImg.img = res.nativeURL
              localStorageService.set(fileName.split('.')[0], welcomeImg);                        //本地图片地址存入localStroge
            },
            //下载失败
            function (err) {
              $cordovaFile.removeFile(rootPath, 'welcomeImg/lock_' + fileName).then(function () {
                console.log('下载失败，删除锁文件');
              });
              $cordovaFile.removeFile(rootPath, 'welcomeImg/' + fileName).then(function () {
                console.log('下载失败，删除错误文件');
              });
            },
            //下载进程
            function (progress) {
              $timeout(function () {
                var downloadProgress = parseInt((progress.loaded / progress.total) * 100);
                downloadProgress % 10 == 0 && console.log(downloadProgress);
              });
            });
        }, function () {
        });
      }
    }

    function img2Base64(localUrl, welcomeImg) {

      welcomeImg.img = adaptation(welcomeImg.img);// 设备屏幕适配

      var img = document.createElement('img');
      img.crossOrigin = "Anonymous";// 开启客户端允许跨域
      img.src = welcomeImg.img;
      img.onload = function () {
        welcomeImg.img = getBase64Image(img);
        localStorageService.set(localUrl, welcomeImg);
        //$scope.welome2Img = data;
      }
    }

    /* 设备屏幕适配 */
    function adaptation(welome2Img) {

      var prefix = welome2Img.substr(0, welome2Img.lastIndexOf('/'));

      var width = window.screen.width;
      var height = window.screen.height;
      var result_56 = Math.abs(0.56 - (width / height));//  ? 720/1280=0.56
      var result_60 = Math.abs(0.60 - (width / height));//  华为pad 601/962=0.62[高度裁剪] 优先使用这个,适当裁剪不至于留白
      var result_66 = Math.abs(0.66 - (width / height));//  华为pad 601/962=0.62[高度留白],如:0.65会适配到0.66有留白风险,暂不考虑
      var result_75 = Math.abs(0.75 - (width / height));//  ipad 1536/2048=0.75
      var result = Math.min.apply(null, [result_56, result_60, result_66, result_75]);

      console.log('window.screen', width, height, width / height);

      if (result_56 == result) {
        console.log('0.56');
        welome2Img = prefix + '/720x1280.jpg';
      } else if (result_60 == result) {
        console.log('0.60');
        welome2Img = prefix + '/720x1184.jpg';
      } else if (result_66 == result) {
        console.log('0.66');
        welome2Img = prefix + '/960x1440.jpg';
      } else if (result_75 == result) {
        console.log('0.75');
        welome2Img = prefix + '/1536x2048.jpg';
      }
      return welome2Img;
    }

    function getBase64Image(img) {
      var canvas = document.createElement("canvas");
      canvas.width = img.width;
      canvas.height = img.height;
      var ctx = canvas.getContext("2d");
      ctx.drawImage(img, 0, 0, img.width, img.height);
      var dataURL = canvas.toDataURL("image/png");
      return dataURL;
      // return dataURL.replace("data:image/png;base64,", "");
    }

    function endTime() {
      $scope.endTime = $rootScope.endTime ? $rootScope.endTime : 4;
      var interval = $interval(function () {
        $scope.endTime--;

        if ($scope.endTime <= 0) {
          $interval.cancel(interval);
          !$scope.close && go();
        }
      }, 1000);
    }

    function go() {
      $scope.close = true;    //关闭计时器
      if (!localStorageService.get("currentUser") && !localStorageService.get('token')) {
        $state.go('login');
      }
      else {
        $state.go('menu.main.exp');
      }

    }

  }
})();
