(function () {
  'use strict'

  angular
    .module('starter')
    .factory('$httpFactory', MainFactory);

  function MainFactory($http, $ionicLoading, $state) {
    var domain_name = _config.domain_name;

    // 设置默认headers
    $http.defaults.headers.post = {
      'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8'
    };

    $http.defaults.headers.common.platform = _config.platform.code;

    /**
     * 设置切面
     */
    $http.defaults.transformRequest = appendTransform($http.defaults.transformRequest, function (value) {
      return value;
    });

    /**
     * 设置切面
     */
      // $http.defaults.transformRequest = appendTransform($http.defaults.transformRequest, function (value) {
      //   return value;
      // });
      // $http.defaults.transformResponse = appendTransform($http.defaults.transformResponse, function (value) {return value;});

    var service = {
        sys: {
          sysConfig: function (key) {
            (key == 'shareApp') && (key += '_' + _config.platform.code);
            var url = domain_name + 'sysConfig?key=' + key;
            return send(url);
          },
          getVersion: function () {
            var url = domain_name + 'entity/version/app_' + _config.platform.code;
            return send(url);
          }
        },
        user: {
          changeNickName: function (userId, loginName, nickName) {
            var data = {
              content: JSON.stringify({
                userId: userId,
                loginName: loginName,
                nickName: nickName
              }), token: _appv.currentUser && _appv.currentUser.token ? _appv.currentUser.token : -1,
            }
            var userId = _appv.currentUser && _appv.currentUser.userId ? _appv.currentUser.userId : -1;
            var url = domain_name + 'user/info/update/' + userId;
            return send(url, 'POST', data);
          },
          bindPhone: function (userId, token, mobile, randomCode) {// 用户手机
            var url = domain_name + 'user/mobile/' + userId;
            var data = {token: token, mobile: mobile, randomCode: randomCode};
            return send(url, 'POST', data);
          },
          changePass: function (userId, loginName, oldPassword, newPassword, token) {
            var data = {
              pwdDTO: JSON.stringify({
                userId: userId,
                loginName: loginName,
                oldPwd: oldPassword,
                newPwd: newPassword
              }), token: token
            };
            var url = domain_name + 'user/password/update/' + userId;
            return send(url, 'POST', data)
          },
          bindPass: function (userId, mobile, password1, password2, token, sign) {
            var data = {
              content: JSON.stringify({
                mobile: mobile,
                sign: sign,
                password1: password1,
                password2: password2,
              }), token: token
            };
            var url = domain_name + 'user/password/set/' + userId;
            return send(url, 'POST', data)
          },
          myQuestionList: function (pageNo) {
            var userId = _appv.currentUser && _appv.currentUser.userId ? _appv.currentUser.userId : -1;
            var pageSize = _app.nomPagesize;
            var url = domain_name + 'errorQt/' + userId + '/?pageSize=' + pageSize + '&currentPage=' + pageNo; // 获取错题
            return send(url);
          },
          myQuestionDel: function (qid) {
            var userId = _appv.currentUser && _appv.currentUser.userId ? _appv.currentUser.userId : -1;
            var url = domain_name + 'errorQt/' + userId + '/' + qid // 删除错题;errorQt/:userId/:id
            return send(url)
          },
          feedback: function (userId, content) {
            var url = domain_name + 'user/suggest';
            return send(url, 'POST', {userId: userId, content: content});
          },
          myMessage: {
            read: function (messageId) {
              var userId = _appv.currentUser && _appv.currentUser.userId ? _appv.currentUser.userId : -1;
              var token = _appv.currentUser && _appv.currentUser.token ? _appv.currentUser.token : -1;
              var url = domain_name + "user/myMessage/read/" + userId;
              var data = {token: token, ids: messageId};
              return send(url, 'POST', data);
            },
            noReadSum: function () {
              var userId = _appv.currentUser && _appv.currentUser.userId ? _appv.currentUser.userId : -1;
              var url = domain_name + 'user/myMessage/noReadSum/' + userId;
              return send(url);
            },
            list: function (pageNo) {
              var pageSize = _app.nomPagesize;
              var userId = _appv.currentUser && _appv.currentUser.userId ? _appv.currentUser.userId : -1;
              var url = domain_name + 'user/myMessage/' + userId + '/' + pageSize + '/' + pageNo;
              return send(url);
            }
          },
          bindingInviteCode: function (inviteCode) {//绑定邀请码
            var userId = _appv.currentUser && _appv.currentUser.userId ? _appv.currentUser.userId : -1;
            var token = _appv.currentUser && _appv.currentUser.token ? _appv.currentUser.token : -1;
            var data = {
              token: token,
              inviteCode: inviteCode
            };
            var url = domain_name + 'user/inviteCode' + '/' + userId;
            return send(url, 'POST', data);
          },
          getInviteCode: function (userId) {
            var url = domain_name + 'user/inviteCode/' + userId;
            return send(url);
          },
          getInvitList: function (userId) {
            var url = domain_name + 'user/inviteUser/' + userId;

            return send(url);
          },
          addLottery: function (userId, token) {
            var type = 1;
            var data = {
              token: token,
              type: type
            };
            var url = domain_name + 'user/lottery/' + userId;
            return send(url, 'POST', data);
          },
          checkOldUser: function (userId) {
            var url = domain_name + 'order/oldUser/' + userId;
            return send(url);
          },
          getReward: function (userId, productCode, token) {
            var url = domain_name + 'order/oldUser/' + userId + '/' + productCode;
            return send(url, 'POST', {token: token});
          }
        },
        school: {
          getGroup: function (userId) {
            var url = domain_name + 'group/findUserGroup/' + userId;
            return send(url);
          },
          shcoolByDisName: function (name) {
            var data = {name: name};
            var url = domain_name + 'school/cityName';
            return send(url, 'POST', data);
          },
          setSchool: function (userId, loginName, schoolId, token) {
            var data = {
              content: JSON.stringify({
                userId: userId,
                loginName: loginName,
                schoolId: schoolId
              }), token: token
            };
            var url = domain_name + 'user/info/update/' + userId;
            return send(url, 'POST', data)
          },
          bindGroup: function (groupId, userId, token) {
            var data = {token: token};
            var url = domain_name + 'group/addUser/' + groupId + '/' + userId;
            return send(url, 'POST', data);
            //return ServiceHandle.user.bindGroup([groupId,userId,token]);
          },

        },
        login: {
          getCode: function (mobile, type) {
            var url = domain_name + "mobile/sendCode/" + mobile;
            // return _response($http.post(url, $.param(data)));
            var data = {type: type};
            return send(url, "POST", data);
          },
          oneLogin: function (mobile, randomCode) {
            var url = domain_name + 'login/oneLogin/student/' + mobile + '/' + randomCode;
            return send(url);
          },
          normalLogin: function (data) {
            var url = domain_name + 'appLogin?type=0';
            return send(url, 'POST', data);
          },
          checkResetCode: function (mobile, data) {
            var url = domain_name + 'mobile/code/' + mobile;
            return send(url, 'POST', data);
          },
          resetPassword: function (data) {
            var url = domain_name + 'resetPassword?type=student';
            return send(url, 'POST', data);
          },
          thirdLogin: function (data) {
            var url = domain_name + 'register/thirdPartyLogin';
            return send(url, 'POST', data);
          },
          sign: function (userId) {
            var url = domain_name + 'actionLog/sign/' + userId;
            return send(url);
          }
        },
        book: {
          bookList: function (userId) {
            var url = domain_name + 'user/bag/' + userId;    // 我的书本
            return send(url);
          }
        },
        exp: {
          expList: function (gradeId, subject) {
            var userId = _appv.currentUser && _appv.currentUser.userId ? _appv.currentUser.userId : -1;
            var url = domain_name + 'user/bag/' + userId + '/' + gradeId + '/' + subject + '/1';// 用户,年级,学科
            return send(url);
          },
          findProduct: function (expId, userId, token) {
            var url = domain_name + 'order/product/exp/' + expId + '/' + userId;
            return send(url, 'POST', {token: token});
          },
          chapterKnowPoint: function (userId, expId) {
            var url = domain_name + 'knowPoint/dtl/' + expId + '/' + userId;
            return send(url)
          }
        },
        selfCenter: {
          area: {
            getAll: function (schoolId) {
              var url = domain_name + 'school/province/city/district/' + schoolId;
              return send(url);
            }
          }
        },
        activity: {
          getList: function (pageSize, currentPage, activityType) {
            if (!activityType) {
              activityType = window._app.activity;
            }
            var url = domain_name + 'questionBank/activity?pageSize=' + pageSize + "&currentPage=" + currentPage + "&activityType=" + activityType
            return send(url);
          },
          getInfo: function (inviteActivityId) {
            var url = domain_name + 'questionBank/activityDtl/' + inviteActivityId
            return send(url);
          }
        },
        browser: function (userId, activityId) {
          var url = domain_name + 'questionBank/activityDtl/' + activityId + '?userId=' + userId;
          return send(url);
        },
        lottery: {
          lottery: function () {
            var url = domain_name + 'lottery/' + userId;// 抽奖

          },
          lotteryLog: function (userId, token) {
            var data = {token: token}
            var url = domain_name + 'lottery/log/' + userId;// 查看中奖记录
            return send(url, 'POST', data);
          },
          saveAddress: function (userId, logWinnerId, token, dataAddress) {
            var data = {
              token: token,
              content: JSON.stringify(dataAddress),
            };
            var url = domain_name + 'lottery/check/' + userId + '/' + logWinnerId;
            return send(url, 'POST', data);
          }
        },
        practice: {
          chapter: function (userId, bookId) {
            var url = domain_name + 'userBag/Chapter/' + userId + '/' + bookId;
            return send(url);
          },
          get_question: function (knowId, sum, data) {
            var url = domain_name + 'questionBank/randomSumQuestion/' + knowId + '/' + sum;
            return send(url, 'POST', data);
          }
        },
        question: {
          save_scores: function (userId, data) {
            var url = domain_name + 'questionBank/randomExercise/' + userId;
            return send(url, 'POST', data);
          },

        },
        product: {
          productList: function (level, knowId, userId, type) {
            // +'?knowId='+knowId+'&userId='+userId+'&type='+type;
            var url = domain_name + 'order/product/' + level + '?';
            knowId && (url = url + '&knowId=' + knowId);
            userId && (url = url + '&userId=' + userId);
            type && (url = url + '&type=' + type);
            return send(url);
          },
          expList: function (productCode) {
            var url = domain_name + 'order/product/exp?'
            productCode && (url = url + 'productCode=' + productCode);
            return send(url);
          }
        },
        order: {
          alipay: function (userId, data) {
            var url = domain_name + 'order/alipay/create/' + userId;
            // var data = {content: JSON.stringify(content)};
            //content =  {"productCode":1}
            return send(url, "POST", data);
          },
          wechatPay: function (userId, data) {
            var url = domain_name + '/order/wechat/create/' + userId;
            // var data = {content: JSON.stringify(content)};
            //content =  {"productCode":1}
            return send(url, "POST", data);
          },
          productShare: function (userId, productCode) {
            var url = domain_name + '/order/product/share/' + userId + '/' + productCode;
            var data = {
              token: _appv.token
            };
            return send(url, "POST", data);
          },
          qqPay: function (userId, data) {
            var url = domain_name + '/order/qpay/create/' + userId;
            return send(url, 'POST', data);
          },
          order_query: function (orderCode) {
            var url = domain_name + '/order/query?orderCode=' + orderCode;
            return send(url);
          },
          order_qrcode: function (content, userId) {
            var url = domain_name + '/order/wechatJSAPI/create/' + userId;
            var data = {content: JSON.stringify(content),token: _appv.token};
            return send(url, 'POST', data);
          }
        },
        video: {
          list: function (userId, categoryId, pageSize, currentPage) {
            var url = domain_name + 'video/video/' + userId + '?';
            categoryId && (url = url + '&categoryId=' + categoryId);
            pageSize && currentPage && (url = url + '&pageSize=' + pageSize + '&currentPage=' + currentPage);
            return send(url);
          },
          search: function (userId, data) {
            var url = domain_name + 'video/search/' + userId;
            return send(url, 'POST', data);
          },
          typeList: function (userId) {
            var url = domain_name + 'video/category/' + userId;
            return send(url)
          },
          updateCategory: function (userId, data) {
            var url = domain_name + 'video/category/' + userId;
            return send(url, 'POST', data);
          },
          myList: function (userId, categoryId, pageSize, currentPage) {
            var url = domain_name + 'video/myVideo/' + userId + '?';
            categoryId && (url = url + 'categoryId=' + categoryId + '&');
            pageSize && currentPage && (url = url + 'pageSize=' + pageSize + '&currentPage=' + currentPage);
            return send(url);
          },
          updateVideo: function (userId, videoCode, token) {
            var url = domain_name + 'video/update/' + userId + '/' + videoCode;
            return send(url, 'POST', {token: token});
          },
          videoPlay: function (userId, productResId) {
            var url = domain_name + 'video/play/' + userId + '/' + productResId;
            return send(url);
          }
        },
        live: {
          list: function (userId) {
            var url = domain_name + 'live/live/' + userId;
            return send(url);
          },
          myList: function (userId, type, token) {
            var url = domain_name + 'live/myLive/' + userId + '?type=' + type;
            var data = {token: token};
            return send(url, 'POST', data);
          },
          getInfo: function (userId, token) {
            var url = domain_name + 'order/product/live/' + userId;
            var data = {token: token};
            return send(url, 'POST', data);
          },
          getPasswordPay: function (userId, token) {
            var url = domain_name + 'order/product/live/password/' + userId;
            var data = {token: token};
            return send(url, 'POST', data);
          },
          getPasswordShare: function (userId, token) {
            var url = domain_name + 'order/product/live/share/' + userId;
            var data = {token: token};
            return send(url, 'POST', data);
          }

        }

      };

    function send(url, method, data) {
      method == 'POST' && (data = $.param(data));

      !method && (method = 'GET');

      var req = {
        url: url,
        method: method,
        data: data,
        timeout: 150000
      };

      method == 'GET' && (req.params = data);

      var _http = $http(req);
      _http.catch(httpCatch);
      _http.finally(httpFinally);

      return _http.then(httpBaseThen, httpCatch);
    }

    function httpBaseThen(response) {
      if (response.data == null || response.data == "") {
        // console.log('response:', (new Date() - start) / 1000 + 's', response.data + "(无结果响应)");
        // $ionicLoading.show({template: 'sorry,服务器无响应...'});
        return Promise.reject(response);// 阻断返回
        // throw new Error('无结果响应');
      }
      if (response.data.message.match('重新登录')) {
        $ionicLoading.show({template: response.data.message});
        _app.routeLock = true;
        $state.go('login');
        return Promise.reject(response);// 阻断返回
      }
      return response;
    }

    function httpCatch(error) {
      return error;
    }

    function httpFinally() {


    }

    return service;

    /**************************************************************************************************************/

    /**
     * 追加切面函数处理
     * @param defaults
     * @param transform
     * @returns {Array.<T>}
     */
    function appendTransform(defaults, transform) {
      // We can't guarantee that the default transformation is an array
      defaults = angular.isArray(defaults) ? defaults : [defaults];

      // Append the new transformation to the defaults
      return defaults.concat(transform);
    }
  }
})();
