/**
 * Created by Administrator on 2016/11/7 0007.
 */
(function () {
  'use strict';
  angular
    .module('starter')
    .factory('PaymentFactory', MainFactory);

  function MainFactory($ionicPopup, $ionicLoading, $httpFactory, $rootScope, $state, RouteData) {

    /**
     * 打开支付选择
     * @param $scope
     * @param page_param
     * @param success_pay
     */
    function openPayChoose($scope, productPay, success_pay, fail_pay) {
      var payHandle_success = false;
      var payHandle_cancel = false;

      $scope.productPay = productPay;
      $scope.page_paySelect = {};
      $scope.paySelectType = 1; //默认家长代付1，自己支付为2
      $scope.page_paySelect = {};
      $scope.page_paySelect.payChoose = 'wechat';// 默认支付方式:微信

      $scope.payNameLeft = productPay.payNameLeft;
      $scope.payNameRight = productPay.payNameRight;
      $scope.discount = productPay.discount;
      $scope.price = productPay.price;

      $scope.payType = payType;
      qrcode();

      //家长扫码支付
      function qrcode() {
        var content = $scope.productPay.content;
        var userId = _appv.currentUser.userId;
        $httpFactory.order.order_qrcode(content, userId).then(function (res) {
          if (res.data.message.match("已经购买")) {
            $ionicLoading.show({template: res.data.message});
            return;
          }
          $scope.myPopup = $ionicPopup.show({
            cssClass: 'myPopup',
            templateUrl: 'app/paySelect/paySelect.html',
            scope: $scope
          });
          $scope.orderInfo = res.data.object;
          if (res.data.result == 0 && res.data.object.status != 1) {
            setTimeout(function () {
              // 安卓9.0初始化二维码，采用的画布样式
              // 安卓8初始化二维码，采用img样式
              // 所以这里初始化时候，带上width,height设置
              $scope.myQrCode = new QRCode(document.getElementById("qrcode"), {
                text: res.data.object.jsapiDto.code_url,
                width: 130,
                height: 130
              })
            }, 200);
          }
        });
        $scope.checkOrder = function () {
          orderCheck($scope.orderInfo.code);// 订单校验
        }
      }

      /**
       * 校验订单
       * @param orderCode
       */
      function orderCheck(orderCode) {
        $httpFactory.order.order_query(orderCode).then(function (request) {
          if (request.data.result == 0) {
            if (request.data.object.status == 1) {// 状态，0待支付，1已支付，2异常|失败，3作废
              window._appv.currentUser.isPayUser = 1;
              afterPay();
              /** 订单支付完成,回调业务 **/
            } else {
              $ionicLoading.hide();
              // $ionicLoading.show({template: '订单尚未支付完成...', duration: 2000});// TODO 微信偶然会自动取消,所以暂不提示
            }
          } else {
            $ionicLoading.hide();
            $ionicLoading.show({template: request.message});
          }
        })
      }

      function afterPay() {
        //购买课件返回
        if ($scope.productPay.productType == _app.orderType_exp) {
          $rootScope.refresherExp();
          $state.go('menu.main.exp');
        }
        //购买套餐返回
        if ($scope.productPay.productType == _app.orderType_book) {
          RouteData.myTrolley = [];
          $rootScope.refresherExp();
          $state.go('menu.main.exp');
        }
        //试听课--题型击破
        if ($scope.productPay.productType == _app.orderType_video) {
          $rootScope.refresherVideo();
          $rootScope.refresherVideoInfo();
          $state.go('menu.videoInfo');
        }
        //试听课--中考提分
        if ($scope.productPay.productType == _app.orderType_master) {
          $rootScope.refresherMasterVideo();
          $state.go('menu.main.videoLive.masterVideo');
        }
      }

      function payType(type) {
        var data = {
          token: _appv.token,
          content: JSON.stringify($scope.productPay.content)
        };

        switch (type) {
          case 'alipay':      //支付宝支付
            $ionicLoading.show({template: '处理中...', duration: 3000});
            aliPay(data);
            break;
          case 'wechat':      //微信支付
            $ionicLoading.show({template: '处理中...', duration: 3000});
            wechatPay(data);
            break;
          case 'qq':          //qq钱包支付
            $ionicLoading.show({template: '处理中...', duration: 3000});
            qqPay(data);
            break;
        }
      }

      function aliPay(data) {
        //生成订单
        $httpFactory.order.alipay(_appv.currentUser.userId, data).then(function (res) {
          if (!res.data.object) {
            $ionicLoading.show({template: res.data.message});
            return;
          }
          var aliDto = res.data.object.aliDto;
          //调用支付宝支付
          window.alipay && window.alipay.pay(aliDto, function (successResults) {
            console.log(successResults);
            $ionicLoading.show({template: '支付成功'});
            payHandle_success = true;
            afterPay();
          }, function (errorResults) {
            console.log(errorResults);
            payHandle_cancel = true;
            // alert('支付失败!');
          });

          // 启动页面再激活监听
          document.addEventListener("resume", function resumeListener() {
            // alert('resume payHandle_cancel:'+payHandle_cancel+' payHandle_success:'+payHandle_success);
            setTimeout(function () {
              if (!payHandle_success) {
                orderCheck(res.data.object.code);// 订单校验
              }
            }, 1000);
            document.removeEventListener("resume", resumeListener);// 删除当前事件监听
          }, false);

        }, function (res) {
          $ionicLoading.show({template: res.data.message});
        });
      }

      function wechatPay(data) {
        $httpFactory.order.wechatPay(_appv.currentUser.userId, data).then(function (response) {
          if (!response.data.object) {
            $ionicLoading.show({template: response.data.message});
            return;
          }
          var dto = response.data.object.dto;
          // alert("dto数据: " + JSON.stringify(dto));
          window.Wechat && window.Wechat.sendPaymentRequest(dto, function () {
            console.log("Success");
            $ionicLoading.show({template: '支付成功'});
            payHandle_success = true;
            afterPay();
            // success_pay();
          }, function (reason) {
            // alert("Failed: " + reason);
            console.log("Failed:", reason);
            payHandle_cancel = true;
            // alert('支付失败!');
          });

          // 启动页面再激活监听
          document.addEventListener("resume", function resumeListener() {
            // alert('resume payHandle_cancel:'+payHandle_cancel+' payHandle_success:'+payHandle_success);
            setTimeout(function () {
              if (!payHandle_success) {
                orderCheck(response.data.object.code);// 订单校验
              }
            }, 1000);
            document.removeEventListener("resume", resumeListener);// 删除当前事件监听
          }, false);
        });
      }

      function qqPay(data) {
        $httpFactory.order.qqPay(_appv.currentUser.userId, data).then(function (res) {
          if (res.data.result == 0) {
            var dto = res.data.object.qpayDto;
            QPay.mqqPay(dto, function (res) {
              if (res.isSuccess || res.match('成功')) {
                $ionicLoading.show({template: '支付成功,若仍显示未订购请返回等待几秒后刷新', duration: 3000});
                payHandle_success = true;
                // alert("支付成功："+JSON.stringify(res));
                afterPay();
              }
            }, function (res) {
              // alert("支付失败:"+JSON.stringify(res));
              payHandle_cancel = true;
            });

            // 启动页面再激活监听
            document.addEventListener("resume", function resumeListener() {
              // alert('resume payHandle_cancel:'+payHandle_cancel+' payHandle_success:'+payHandle_success);
              setTimeout(function () {
                if (!payHandle_success) {
                  orderCheck(res.data.object.orders.code);// 订单校验
                }
              }, 1000);
              document.removeEventListener("resume", resumeListener);// 删除当前事件监听
            }, false);
          }
        });
      }

    }

    var service = {
      openPayChoose: openPayChoose,
    };
    return service;
  }

})();
