(function () {
  'use strict';

  angular.module('starter')
    .factory('AppFactory', MainFactory);

  function MainFactory($rootScope, $ionicViewSwitcher, $state, $ionicLoading, localStorageService, $ionicHistory, $ionicSideMenuDelegate, $timeout) {
    function stateChange() {
      $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
        //路由锁设置
        if (toState && toState.name && !toState.name.match('main')) {         //二级main页面有缓存机制，不用锁
          if (!_app.routeLock) {
            event && event.preventDefault();// 阻止模板解析
            return;
          }
          //设置路由锁维持时间
          _app.routeLock = false;
          $timeout(function () {
            _app.routeLock = true;
          }, 500);
        }

        //需登录的路由设置，禁止游客点击
        // var routeUrl = ['/pay','/selfCenter','/videoLive'];
        var routeUrl = ['/pay', '/videoLive','/selfCenter'];
        for (var i = 0; i < routeUrl.length; i++) {
          if (toState && toState.url && toState.url.match(routeUrl[i]) && _appv.currentUser.userId == -1) {
            break;
          }
        }
        if (i < routeUrl.length) {
          $ionicLoading.show({template: '请先登录'});
          _app.routeLock = true;
          $state.go('login');
          event && event.preventDefault();// 阻止模板解析
          return;
        }

        //欢迎页到活动页的返回处理
        if (fromState.url.match('/myActivity')) {
          if (toState.url.match('/welcome')) {
            if (localStorageService.get('myBook')) {
              event && event.preventDefault();
              _app.routeLock = true;
              $state.go('home');
            } else {
              _app.routeLock = true;
              $state.go('menu.main.exp');
            }
          }
        }
        // 设置可以拖拽打开侧边栏的页面
        if (('/menu.main.exp,/menu.main.practice').match(toState.name)) {
          $ionicSideMenuDelegate.canDragContent(true);
          $ionicSideMenuDelegate.edgeDragThreshold(false);
        } else {
          $ionicSideMenuDelegate.canDragContent(false);
        }
      });
      $rootScope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
        // _app.routeLock = true;   //打开路由锁

        //以第二级别main路由为主体，进入main时清空历史路由重新记录，
        if (fromState.name.match('main.')) {
          $ionicHistory.clearHistory();
        }
        console.log('from:', fromState.url, 'To:', toState.url, toState.controller, 'toParams:', toParams);
        // $ionicViewSwitcher.nextDirection('forward');     //恢复路由跳转初始动画
      });
    }

    var service = {
      stateChange: stateChange
    };

    return service;
  }
})();
