// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter')
  .run(RunFactory);

function RunFactory(AppFactory, $ionicPlatform, $ionicHistory, $location, $rootScope, $cordovaToast, $cordovaAppVersion, $httpFactory, $state, localStorageService) {

  console.timeEnd('@App.run');
  console.time('App.run');

  {
    initLocalData();// 恢复本地数据
    AppFactory.stateChange();// 路由变化控制

    console.timeEnd('App.run');
    console.time('App first state');

  }

  $ionicPlatform.ready(function () {
    console.timeEnd('$ionicPlatform.ready');
    console.log('splash.$ionicPlatform.ready', navigator.splashscreen);
    navigator.splashscreen && navigator.splashscreen.hide();// 加载完毕后关闭启动屏幕

    iosAuditSwitch();// 初始化ios审核开关(依赖$cordovaAppVersion插件)

    $rootScope.endTime = 4;
    // if(!$rootScope.endTime()){
    //   $rootScope.endTime()
    // }else{
    //  $timeout(function(){
    //      $rootScope.endTime()
    //  },1000);
    // }
    // AppFactory.app_backButtonAction();// app系统返回键控制
    // ShareFactory.initShare();// 初始化第三方分享(需插件初始化完成后)

    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    !_app.isWeb && window.screen.orientation.lock("portrait");
    !_app.isWeb && (typeof umengService !== 'undefined') && umengService.init({"args": "init"});// 初始化友盟
    listenBackButton();
  });

  function listenBackButton() {
    //物理返回按钮控制&双击退出应用
    $ionicPlatform.registerBackButtonAction(function (e) {
      //判断处于哪个页面时双击退出
      if ($location.path() == '/home' || $location.path() == '/menu/main/exp'
        || $location.path().match('/main') || $location.path().match('/login') || $location.path().match('/welcome')) {
        if ($rootScope.backButtonPressedOnceToExit) {
          ionic.Platform.exitApp();
        } else {
          $rootScope.backButtonPressedOnceToExit = true;
          $cordovaToast.showShortBottom('再按一次退出系统');
          setTimeout(function () {
            $rootScope.backButtonPressedOnceToExit = false;
          }, 2000);
        }
      } else if ($location.path() == '/menu/questionFinish') {
        $state.go('menu.main.practice');
      } else if ($ionicHistory.viewHistory().backView) {
        $ionicHistory.goBack();
      }
      else {
        $state.go('menu.main.exp');
      }
      e.preventDefault();
      return false;
    }, 101);
  }

  function initLocalData() {
    $rootScope.isWeb = _app.isWeb;
    $rootScope.isAndroid = _app.isAndroid;
    $rootScope.isIos = _app.isIos;

    $rootScope.myBook = _app.bookList[0];

    if (!localStorageService.get("currentUser")) {
      _appv.currentUser = {userId: -1};
    }
    else {
      _appv.currentUser = localStorageService.get("currentUser");
      _appv.token = localStorageService.get('token');
    }
    // $httpFactory.login.sign(_appv.currentUser.userId).then(function(res){});
  }

  /**
   * ios审核开关
   */
  function iosAuditSwitch() {
    $rootScope.iosPayOpen = true;     //默认显示支付
    if (!!_app.isIos) {
      $rootScope.iosPayOpen = false;    //ios时默认关闭
      $cordovaAppVersion.getVersionNumber().then(function (response) {
        var key = 'iosPayOpen_' + _config.platform.code + ':' + response;
        $httpFactory.sys.sysConfig(key).then(function (res) {
          if (res.data.result == 0) {
            $rootScope.iosPayOpen = res.data.object[0].value.match('true') ? true : false;
          }
        });
      });
    }
  }
}

